`timescale 1ns / 1ps


///////////////////////////////////////////////////////////////
//                                                           //
// Module for Dual Port Memory for 6k deep by 16 bit FIFO    //
//                                                           //
///////////////////////////////////////////////////////////////

//module dpm_6kX16(CLK,WE,WADDR,RADDR,DIN,DOUT);
//
//input CLK;
//input WE;
//input [12:0] WADDR;
//input [12:0] RADDR;
//input [15:0] DIN;
//output [15:0] DOUT;
//
//wire [15:0] DOUT_A,DOUT_B,DOUT_C,DOUT_D,DOUT_E,DOUT_F;
//reg  WE_A,WE_B,WE_C,WE_D,WE_E,WE_F;
//reg [2:0] MSEL;
//reg [15:0] DOUT;
//
//// 6k DPM made from 6 1k DPM's
//dpm_1kX16 dpm_A (.clk(CLK),.we(WE_A),.a(WADDR[9:0]),.dpra(RADDR[9:0]),.di(DIN),.dpo(DOUT_A)); 
//dpm_1kX16 dpm_B (.clk(CLK),.we(WE_B),.a(WADDR[9:0]),.dpra(RADDR[9:0]),.di(DIN),.dpo(DOUT_B)); 
//dpm_1kX16 dpm_C (.clk(CLK),.we(WE_C),.a(WADDR[9:0]),.dpra(RADDR[9:0]),.di(DIN),.dpo(DOUT_C)); 
//dpm_1kX16 dpm_D (.clk(CLK),.we(WE_D),.a(WADDR[9:0]),.dpra(RADDR[9:0]),.di(DIN),.dpo(DOUT_D)); 
//dpm_1kX16 dpm_E (.clk(CLK),.we(WE_E),.a(WADDR[9:0]),.dpra(RADDR[9:0]),.di(DIN),.dpo(DOUT_E)); 
//dpm_1kX16 dpm_F (.clk(CLK),.we(WE_F),.a(WADDR[9:0]),.dpra(RADDR[9:0]),.di(DIN),.dpo(DOUT_F)); 
//
//// Write Enable is directed to one of 6 DPM's to increase depth
//always @(WE or WADDR)
//begin
//  if (WE)
//    case (WADDR[12:10])
//       3'o0: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b100000; 
//       3'o1: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b010000; 
//       3'o2: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b001000; 
//       3'o3: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b000100; 
//       3'o4: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b000010; 
//       3'o5: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b000001; 
//       default: {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b000000;
//    endcase
//  else
//    {WE_A,WE_B,WE_C,WE_D,WE_E,WE_F} <= 6'b000000;
//end
// 
//// Output of the 6 DPM's multiplexed to a common bus.
//always @(posedge CLK)
//  MSEL <= RADDR[12:10];
//
//always @(MSEL or DOUT_A or DOUT_B or DOUT_C or DOUT_D or DOUT_E or DOUT_F)
//begin
//  case (MSEL)
//    3'o0: DOUT <= DOUT_A;
//    3'o1: DOUT <= DOUT_B;
//    3'o2: DOUT <= DOUT_C;
//    3'o3: DOUT <= DOUT_D;
//    3'o4: DOUT <= DOUT_E;
//    3'o5: DOUT <= DOUT_F;
//    default: DOUT <= 16'hXXXX;
//  endcase
//end
//
//// 
////// Output of the 6 DPM's to a common bus with tri-state buffers.
////always @(RADDR[12:10] or DOUT_A )
////   if (RADDR[12:10] == 3'o0)      //active high enable
////      DOUT <= DOUT_A;
////   else
////      DOUT <= 16'hZZZZ;
////always @(RADDR[12:10] or DOUT_B )
////   if (RADDR[12:10] == 3'o1)      //active high enable
////      DOUT <= DOUT_B;
////   else
////      DOUT <= 16'hZZZZ;
////always @(RADDR[12:10] or DOUT_C )
////   if (RADDR[12:10] == 3'o2)      //active high enable
////      DOUT <= DOUT_C;
////   else
////      DOUT <= 16'hZZZZ;
////always @(RADDR[12:10] or DOUT_D )
////   if (RADDR[12:10] == 3'o3)      //active high enable
////      DOUT <= DOUT_D;
////   else
////      DOUT <= 16'hZZZZ;
////always @(RADDR[12:10] or DOUT_E )
////   if (RADDR[12:10] == 3'o4)      //active high enable
////      DOUT <= DOUT_E;
////   else
////      DOUT <= 16'hZZZZ;
////always @(RADDR[12:10] or DOUT_F )
////   if (RADDR[12:10] == 3'o5)      //active high enable
////      DOUT <= DOUT_F;
////   else
////      DOUT <= 16'hZZZZ;
////
////  
//endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Module for inferring a 1k by 16 bit Dual Port Memory      //
//                                                           //
///////////////////////////////////////////////////////////////
 
module dpm_1kX16 (clk, we, a, dpra, di, spo, dpo); 
 
 input        clk; 
 input        we; 
 input  [9:0] a; 
 input  [9:0] dpra; 
 input  [15:0] di; 
 output [15:0] spo; 
 output [15:0] dpo; 
 
 reg    [15:0] ram [1023:0]; 
 reg [15:0] spo; 
 reg [15:0] dpo; 

 always @(posedge clk)
 begin 
    if (we) 
       ram[a] <= di;
    else 
       spo <= ram[a];
    dpo <= ram[dpra];
 end  
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Module for inferring a 8k by 2 bit Dual Port Memory       //
//                                                           //
///////////////////////////////////////////////////////////////
 
module dpm_8kX2 (clk, we, a, dpra, di, spo, dpo); 
 
 input        clk; 
 input        we; 
 input  [12:0] a; 
 input  [12:0] dpra; 
 input  [1:0] di; 
 output [1:0] spo; 
 output [1:0] dpo; 
 
 reg    [1:0] ram [8191:0]; 
 reg [1:0] spo; 
 reg [1:0] dpo; 

 always @(posedge clk)
 begin 
    if (we) 
       ram[a] <= di;
    else 
       spo <= ram[a];
    dpo <= ram[dpra];
 end  
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// Module for Dual Port Memory for 8k deep by 16 bit FIFO    //
//                                                           //
///////////////////////////////////////////////////////////////

module dpm_8kX16(CLK,WE,WADDR,RADDR,DIN,DOUT);

input CLK;
input WE;
input [12:0] WADDR;
input [12:0] RADDR;
input [15:0] DIN;
output [15:0] DOUT;

wire [15:0] DOUT;

// 8k 16 bit DPM  made from 8 2-bit 8k DPM's
dpm_8kX2 dpm_A (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[1:0]),.dpo(DOUT[1:0])); 
dpm_8kX2 dpm_B (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[3:2]),.dpo(DOUT[3:2])); 
dpm_8kX2 dpm_C (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[5:4]),.dpo(DOUT[5:4])); 
dpm_8kX2 dpm_D (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[7:6]),.dpo(DOUT[7:6])); 
dpm_8kX2 dpm_E (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[9:8]),.dpo(DOUT[9:8])); 
dpm_8kX2 dpm_F (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[11:10]),.dpo(DOUT[11:10])); 
dpm_8kX2 dpm_G (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[13:12]),.dpo(DOUT[13:12])); 
dpm_8kX2 dpm_H (.clk(CLK),.we(WE),.a(WADDR[12:0]),.dpra(RADDR[12:0]),.di(DIN[15:14]),.dpo(DOUT[15:14])); 
 
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// Module for simulating the external IDT FIFO               //
//                                                           //
// Non registered output                                     //
//                                                           //
///////////////////////////////////////////////////////////////
 
module dmy_dpm_1kX36 (clk, we, a, dpra, di, spo, dpo); 
 
 input        clk; 
 input        we; 
 input  [9:0] a; 
 input  [9:0] dpra; 
 input  [35:0] di; 
 output [35:0] spo; 
 output [35:0] dpo; 
 
 reg    [35:0] ram [1023:0]; 
 reg [35:0] spo; 
 wire [35:0] dpo; 

 always @(posedge clk)
 begin 
    if (we) 
       ram[a] <= di;
    else 
       spo <= ram[a];
 end  
assign    dpo = ram[dpra];

endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Module for inferring a 1k by 18 bit Dual Port Memory      //
//                                                           //
///////////////////////////////////////////////////////////////
 
//module dpm_1kX18 (clk, we, a, dpra, di, spo, dpo); 
// 
// input        clk; 
// input        we; 
// input  [9:0] a; 
// input  [9:0] dpra; 
// input  [17:0] di; 
// output [17:0] spo; 
// output [17:0] dpo; 
// 
// reg    [17:0] ram [1023:0]; 
// reg [17:0] spo; 
// reg [17:0] dpo; 
//
// always @(posedge clk)
// begin 
//    if (we) 
//       ram[a] <= di;
//    else 
//       spo <= ram[a];
//    dpo <= ram[dpra];
// end  
//endmodule

////////////////////////////////////////////////////////////////////////
//                                                                    //
// Module for inferring a dp deep by n bit wide Dual Port Memory      //
//                                                                    //
////////////////////////////////////////////////////////////////////////
 
module blk_dpm_dpXn (clk, we, a, dpra, di, spo, dpo); 
parameter p2depth = 9; // Default depth in words
parameter width = 36; // Default width in bits
 
 input        clk; 
 input        we; 
 input  [p2depth-1:0] a; 
 input  [p2depth-1:0] dpra; 
 input  [width-1:0] di; 
 output [width-1:0] spo; 
 output [width-1:0] dpo; 
 
 reg    [width-1:0] ram [(1<<p2depth)-1:0]; 
 reg [width-1:0] spo; 
 reg [width-1:0] dpo; 

 always @(posedge clk)
 begin 
    if (we) 
       ram[a] <= di;
    else 
       spo <= ram[a];
    dpo <= ram[dpra];
 end  
endmodule
///////////////////////////////////////////////////////////////
//                                                           //
// Module for inferring a 16 by 18 bit Dual Port Memory      //
// Using distributed RAM                                     //
//                                                           //
///////////////////////////////////////////////////////////////

// synthesis attribute ram_style of dpm_16X18 is distributed
 
module dpm_16X18 (clk, we, a, dpra, di, spo, dpo); 
 
 input        clk; 
 input        we; 
 input  [3:0] a; 
 input  [3:0] dpra; 
 input  [17:0] di; 
 output [17:0] spo; 
 output [17:0] dpo; 
 
 reg    [17:0] ram [15:0]; 
 reg [17:0] spo; 
 reg [17:0] dpo; 

 always @(posedge clk)
 begin 
    if (we) 
       ram[a] <= di;
    else 
       spo <= ram[a];
    dpo <= ram[dpra];
 end  
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Module for inferring a                                    //
// dp deep by n bit wide Dual Port Memory                    //
// Using distributed RAM                                     //
//                                                           //
///////////////////////////////////////////////////////////////

// synthesis attribute ram_style of dst_dpm_dpXn is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_1 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_2 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_3 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_4 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_5 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_6 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_7 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_8 is distributed
// synthesis attribute ram_style of dst_dpm_dpXn_9 is distributed
 
module dst_dpm_dpXn (clk, we, a, dpra, di, spo, dpo); 
parameter p2depth = 6; // Default depth in words
parameter width = 16; // Default width in bits
 
 input        clk; 
 input        we; 
 input  [p2depth-1:0] a; 
 input  [p2depth-1:0] dpra; 
 input  [width-1:0] di; 
 output [width-1:0] spo; 
 output [width-1:0] dpo; 
 
 reg    [width-1:0] ram [(1<<p2depth)-1:0]; 
 reg [width-1:0] spo; 
 reg [width-1:0] dpo; 

 always @(posedge clk)
 begin 
    if (we) 
       ram[a] <= di;
    else 
       spo <= ram[a];
    dpo <= ram[dpra];
 end  
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// Module for a distributed RAM FIFO                         //
//                                                           //
///////////////////////////////////////////////////////////////

module fifo_dpXn_dst(clk,rst,push,pop,mt,full,amt,af,wterr,rderr,din,dout,cnt);
parameter p2depth = 6; // Default depth in words expressed as a power of 2 (ie 2^6 = 64)
parameter width = 16; // Default width in bits
parameter almostmt = 4; // 
parameter almostfull = (1<<p2depth) - 4; // 

input clk;
input rst;
input push;
input pop;
input [width-1:0] din;
output mt;
output full;
output amt;
output af;
output wterr;
output rderr;
output [width-1:0] dout;
output [p2depth-1:0] cnt;

wire [p2depth-1:0] waddr;
wire [p2depth-1:0] raddr;
wire ce;
wire dir;
wire ppop;
wire ppush;
wire wterr;
wire rderr;

assign   mt = ~|cnt;
assign   full = &cnt;
assign   amt = (cnt <= almostmt);
assign   af = (cnt >= almostfull);
//assign   mt = (cnt == 6'h00);
//assign   full = (cnt == 6'h3F);
//assign   amt = (cnt <= 6'h4);
//assign   af = (cnt >= 6'h3C);

defparam dp_fifo.p2depth = p2depth;
defparam dp_fifo.width = width;
defparam ffdp_wrt_ptr.width = p2depth;
defparam ffdp_rd_ptr.width = p2depth;
defparam ffdp_cntr.width = p2depth;

cnt_up ffdp_wrt_ptr (.clk(clk),.inc(ppush),.r(rst),.count(waddr));
// dp X n Dual Port RAM using distributed memory for fifo
dst_dpm_dpXn dp_fifo(.clk(clk),.we(ppush),.a(waddr),.dpra(raddr),.di(din),.dpo(dout)); 
cnt_up  ffdp_rd_ptr (.clk(clk),.inc(ppop),.r(rst),.count(raddr));

cnt_up_dwn ffdp_cntr (.clk(clk),.ce(ce),.dir(dir),.r(rst),.count(cnt));

ffpp_ctrl ffdp_ctrl (.mt(mt),.full(full),.push(push),.pop(pop),.ce(ce),.dir(dir),.ppop(ppop),.ppush(ppush),.wterr(wterr),.rderr(rderr));

endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Module for controlling FIFO pushes pops and counter       //
//                                                           //
///////////////////////////////////////////////////////////////

module ffpp_ctrl(mt,full,push,pop,ce,dir,ppop,ppush,wterr,rderr);

input mt;
input full;
input push;
input pop;
output ce;
output dir;
output ppop;
output ppush;
output wterr;
output rderr;

reg ce;
reg dir;
reg ppop;
reg ppush;
reg wterr;
reg rderr;

always @ (mt or full or push or pop)
begin
  casex ({mt,full,push,pop})
     4'b01x1,4'b0001:
       begin                 // count down
         ce <= 1'b1;
         dir <= 1'b0;
         ppop <= 1'b1;         // Increment read address
         ppush <= 1'b0;         // Don't increment write address
       end
     4'b101x,4'b0010:
       begin                 // count up
         ce <= 1'b1;         
         dir <= 1'b1;
         ppop <= 1'b0;         // Don't increment read address
         ppush <= 1'b1;         // Increment write address
       end
     4'b011:
       begin                 // hold
         ce <= 1'b0;
         dir <= 1'b1;
         ppop <= 1'b1;         // Increment read address
         ppush <= 1'b1;         // Increment write address
       end
     default:                 // hold
       begin
         ce <= 1'b0;
         dir <= 1'b1;
         ppop <= 1'b0;         // Don't increment address
         ppush <= 1'b0;         // Don't increment write address
       end
  endcase
end
always @ (mt or full or push or pop)
begin
  casex ({mt,full,push,pop})
     4'b011x:
       begin                 // write error
         wterr <= 1'b1;
         rderr <= 1'b0;
       end
     4'b10x1:
       begin                 // read error
         wterr <= 1'b0;
         rderr <= 1'b1;
       end
     4'b11xx:
       begin                 // mt and full error
         wterr <= 1'b1;
         rderr <= 1'b1;
       end
     default:                 // no error
       begin
         wterr <= 1'b0;
         rderr <= 1'b0;
       end
  endcase
end
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// Module Block RAM FIFO                                     //
//                                                           //
///////////////////////////////////////////////////////////////

module fifo_dpXn_blk(clk,rst,push,pop,mt,full,amt,af,wterr,rderr,din,dout,cnt);
parameter p2depth = 9; // Default depthin words expressed as a power of 2 (ie 2^6 = 64)
parameter width = 36; // Default width in bits
parameter almostmt = 32; // 
parameter almostfull = (1<<p2depth) - 64; // 

input clk;
input rst;
input push;
input pop;
input [width-1:0] din;
output mt;
output full;
output amt;
output af;
output wterr;
output rderr;
output [width-1:0] dout;
output [p2depth-1:0] cnt;

wire [p2depth-1:0] waddr;
wire [p2depth-1:0] raddr;
wire ce;
wire dir;
wire ppop;
wire push;
wire wterr;
wire rderr;

assign   mt = ~|cnt;
assign   full = &cnt;
assign   amt = (cnt <= almostmt);
assign   af = (cnt >= almostfull);
//assign   mt = (cnt == 9'h000);
//assign   full = (cnt == 9'h1FF);
//assign   amt = (cnt <= 9'h020);
//assign   af = (cnt >= 9'h1C0);

defparam dp_fifo.p2depth = p2depth;
defparam dp_fifo.width = width;
defparam ffdp_wrt_ptr.width = p2depth;
defparam ffdp_rd_ptr.width = p2depth;
defparam ffdp_cntr.width = p2depth;

cnt_up ffdp_wrt_ptr (.clk(clk),.inc(ppush),.r(rst),.count(waddr));
// dp X n Dual Port Block RAM for FIFO
blk_dpm_dpXn dp_fifo(.clk(clk),.we(ppush),.a(waddr),.dpra(raddr),.di(din),.dpo(dout)); 
cnt_up  ffdp_rd_ptr (.clk(clk),.inc(ppop),.r(rst),.count(raddr));

cnt_up_dwn ffdp_cntr (.clk(clk),.ce(ce),.dir(dir),.r(rst),.count(cnt));

ffpp_ctrl ffdp_ctrl (.mt(mt),.full(full),.push(push),.pop(pop),.ce(ce),.dir(dir),.ppop(ppop),.ppush(ppush),.wterr(wterr),.rderr(rderr));

endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Up counter with asynchonous reset                         //
// and parameterized width                                   //
//                                                           //
///////////////////////////////////////////////////////////////

//module cnt_up_ar(clk,inc,r,count);
//parameter width = 16; // Default counter width in bits
//
//input clk;
//input inc;
//input r;
//output [width-1:0] count;
//
//reg [width-1:0] count;
//
//always @ (posedge clk or posedge r)
//begin
//   if (r)
//      count <= 0;
//   else
//      if (inc)
//         count <= count + 1;
//      else
//         count <= count;
//end
//endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Up counter with synchonous reset and parameterized width  //
//                                                           //
///////////////////////////////////////////////////////////////

module cnt_up(clk,inc,r,count);
parameter width = 16; // Default counter width in bits

input clk;
input inc;
input r;
output [width-1:0] count;

reg [width-1:0] count;

always @ (posedge clk)
begin
   if (r)
      count <= 0;
   else if (inc)
      count <= count + 1;
   else
      count <= count;
end
endmodule

//module cnt_up_8(clk,inc,r,count);
//// 8 Bit instance
//input clk,inc,r;
//output [7:0] count;
//defparam cu_8.width = 8;
//cnt_up   cu_8 (.clk(clk),.inc(inc),.r(r),.count(count));
//endmodule

module cnt_up_9(clk,inc,r,count);
// 9 Bit instance
input clk,inc,r;
output [8:0] count;
defparam cu_9.width = 9;
cnt_up   cu_9 (.clk(clk),.inc(inc),.r(r),.count(count));
endmodule

module cnt_up_10(clk,inc,r,count);
// 10 Bit instance
input clk,inc,r;
output [9:0] count;
defparam cu_10.width = 10;
cnt_up   cu_10 (.clk(clk),.inc(inc),.r(r),.count(count));
endmodule

module cnt_up_13(clk,inc,r,count);
// 13 Bit instance
input clk,inc,r;
output [12:0] count;
defparam cu_13.width = 13;
cnt_up   cu_13 (.clk(clk),.inc(inc),.r(r),.count(count));
endmodule

module cnt_up_32(clk,inc,r,count);
// 32 Bit instance
input clk,inc,r;
output [31:0] count;
defparam cu_32.width = 32;
cnt_up   cu_32 (.clk(clk),.inc(inc),.r(r),.count(count));
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Loadable up counter with synchonous reset and             //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module cnt_up_l(clk,inc,r,l,din,count);
parameter width = 16; // Default counter width in bits

input clk;
input inc;
input r;
input l;
input [width-1:0] din;
output [width-1:0] count;

reg [width-1:0] count;

always @ (posedge clk)
begin
   if (r)
      count <= 0;
   else if (l)
      count <= din;
   else if (inc)
      count <= count + 1;
   else
      count <= count;
end
endmodule

module cnt_up_l_10(clk,inc,r,l,din,count);
// 10 Bit instance
input clk,inc,r,l;
input [9:0] din;
output [9:0] count;
defparam cul_10.width = 10;
cnt_up_l cul_10 (.clk(clk),.inc(inc),.r(r),.l(l),.din(din),.count(count));
endmodule

module cnt_up_l_13(clk,inc,r,l,din,count);
// 13 Bit instance
input clk,inc,r,l;
input [12:0] din;
output [12:0] count;
defparam cul_13.width = 13;
cnt_up_l cul_13 (.clk(clk),.inc(inc),.r(r),.l(l),.din(din),.count(count));
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Loadable down counter with synchonous reset and           //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module cnt_dn_l(clk,dec,r,l,din,count);
parameter width = 16; // Default counter width in bits

input clk;
input dec;
input r;
input l;
input [width-1:0] din;
output [width-1:0] count;

reg [width-1:0] count;

always @ (posedge clk)
begin
   if (r)
      count <= 0;
   else if (l)
      count <= din;
   else if (dec)
      count <= count - 1;
   else
      count <= count;
end
endmodule

module cnt_dn_l_13(clk,dec,r,l,din,count);
// 13 Bit instance
input clk,dec,r,l;
input [12:0] din;
output [12:0] count;
defparam cdl_13.width = 13;
cnt_dn_l cdl_13 (.clk(clk),.dec(dec),.r(r),.l(l),.din(din),.count(count));
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// Specialized counter !!!!                                  //
// Up counter with synchonous reset to 0 or 1                //
// and parameterized width                                   //
//                                                           //
///////////////////////////////////////////////////////////////

module cnt_up_r10(clk,inc,r,count);
parameter width = 16; // Default counter width in bits

input clk;
input inc;
input r;
output [width-1:0] count;

reg [width-1:0] count;

always @ (posedge clk)
begin
   if (r)
      if(inc)
         count <= 1;
      else
         count <= 0;
   else if (inc)
      count <= count + 1;
   else
      count <= count;
end
endmodule

module cnt_up_r10_13(clk,inc,r,count);
// 13 Bit instance
input clk,inc,r;
output [12:0] count;
defparam cu_r10_13.width = 13;
cnt_up_r10   cu_r10_13 (.clk(clk),.inc(inc),.r(r),.count(count));
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Bi-Directional Register with output enable                //
//                                                           //
///////////////////////////////////////////////////////////////

module bi_dir_reg(CLK, DIR, EN, A, B);

    input CLK;
    input DIR;
    input EN;
    inout [15:0] A;
    inout [15:0] B;
   
reg [15:0] BDREG;

assign A = (EN && DIR) ? BDREG : 16'hZZZZ;
assign B = (EN && !DIR) ? BDREG : 16'hZZZZ;

always @(posedge CLK)
begin
   if (DIR)
      BDREG <= B;
   else
      BDREG <= A;
end      
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Register with output enable                               //
//                                                           //
///////////////////////////////////////////////////////////////

module loopback(clk, ena, lp_in, lp_out);

    input clk;
    input ena;
    input [15:0] lp_in;
   output [15:0] lp_out;

reg [15:0] dreg;
reg [15:0] lp_out;

always @(posedge clk)
      dreg <= lp_in;
always @(ena or dreg)
   if (ena)      //active high enable
      lp_out = dreg;
   else
      lp_out = 16'bZ;
         
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Register with clock enable and synchronous reset and      //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module reg_ce(clk,ce,r,din,dout);
parameter width = 16; // Default counter width in bits

input clk;
input ce;
input r;
input [width-1:0] din;
output [width-1:0] dout;

reg [width-1:0] dout;

always @ (posedge clk)
begin
   if (r)
      dout <= 0;
   else if (ce)
      dout <= din;
   else
      dout <= dout;
end
endmodule

//module reg_ce_4(clk,ce,r,din,dout);
//// 4 Bit instance
//input clk,ce,r;
//input [3:0] din;
//output [3:0] dout;
//defparam rce_4.width = 4;
//reg_ce   rce_4 (.clk(clk),.ce(ce),.r(r),.din(din),.dout(dout));
//endmodule

module reg_ce_8(clk,ce,r,din,dout);
// 8 Bit instance
input clk,ce,r;
input [7:0] din;
output [7:0] dout;
defparam rce_8.width = 8;
reg_ce   rce_8 (.clk(clk),.ce(ce),.r(r),.din(din),.dout(dout));
endmodule

module reg_ce_10(clk,ce,r,din,dout);
// 10 Bit instance
input clk,ce,r;
input [9:0] din;
output [9:0] dout;
defparam rce_10.width = 10;
reg_ce   rce_10 (.clk(clk),.ce(ce),.r(r),.din(din),.dout(dout));
endmodule

module reg_ce_13(clk,ce,r,din,dout);
// 13 Bit instance
input clk,ce,r;
input [12:0] din;
output [12:0] dout;
defparam rce_13.width = 13;
reg_ce   rce_13 (.clk(clk),.ce(ce),.r(r),.din(din),.dout(dout));
endmodule

module reg_ce_16(clk,ce,r,din,dout);
// 16 Bit instance
input clk,ce,r;
input [15:0] din;
output [15:0] dout;
defparam rce_16.width = 16;
reg_ce   rce_16 (.clk(clk),.ce(ce),.r(r),.din(din),.dout(dout));
endmodule

module reg_ce_32(clk,ce,r,din,dout);
// 32 Bit instance
input clk,ce,r;
input [31:0] din;
output [31:0] dout;
defparam rce_32.width = 32;
reg_ce   rce_32 (.clk(clk),.ce(ce),.r(r),.din(din),.dout(dout));
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Up/Down counter with clock enable synchonous reset and    //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module cnt_up_dwn(clk,ce,dir,r,count);
parameter width = 16; // Default counter width in bits

input clk;
input ce;
input dir;
input r;
output [width-1:0] count;

reg [width-1:0] count;

initial
begin
   count = 0;
end

always @ (posedge clk)
begin
   if (r)
      count <= 0;
   else if (ce)
      if (dir)
         count <= count + 1;
      else
         count <= count - 1;
   else
      count <= count;
end
endmodule

module cnt_up_dwn_9(clk,ce,dir,r,count);
// 9 Bit instance
input clk,ce,dir,r;
output [8:0] count;
defparam cud_9.width = 9;
cnt_up_dwn   cud_9 (.clk(clk),.ce(ce),.dir(dir),.r(r),.count(count));
endmodule

module cnt_up_dwn_13(clk,ce,dir,r,count);
// 13 Bit instance
input clk,ce,dir,r;
output [12:0] count;
defparam cud_13.width = 13;
cnt_up_dwn   cud_13 (.clk(clk),.ce(ce),.dir(dir),.r(r),.count(count));
endmodule

///////////////////////////////////////////////////////////////
// Loadable                                                  //
// Up/Down counter with clock enable synchonous reset and    //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module cnt_up_dwn_l(clk,ce,dir,r,l,din,count);
parameter width = 16; // Default counter width in bits

input clk;
input ce;
input dir;
input r;
input l;
input [width-1:0] din;
output [width-1:0] count;

reg [width-1:0] count;

always @ (posedge clk)
begin
   if (r)
      count <= 0;
   else if (ce)
      if (l)
         count <= din;
      else
         if (dir)
            count <= count + 1;
         else
            count <= count - 1;
   else
      count <= count;
end
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// 2 to 1 MUX with parameterized width                       //
//                                                           //
///////////////////////////////////////////////////////////////

module mux2to1(sel,ain,bin,out);
parameter width = 16; // Default data width in bits

input sel;
input [width-1:0] ain,bin;
output [width-1:0] out;

reg [width-1:0] out;

always @ (sel or ain or bin)
begin
   if (sel)
      out <= bin;
   else 
      out <= ain;
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// 2 to 1 MUX with registered output and parameterized width //
//                                                           //
///////////////////////////////////////////////////////////////

//module mux2to1_reg(clk,sel,ain,bin,out);
//parameter width = 16; // Default data width in bits
//
//input clk;
//input sel;
//input [width-1:0] ain,bin;
//output [width-1:0] out;
//
//reg [width-1:0] out;
//
//always @ (posedge clk)
//begin
//   if (sel)
//      out <= bin;
//   else 
//      out <= ain;
//end
//endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// 2 to 1 MUX with registered and tri-stated output          //
// 16 bit fixed width                                        //
//                                                           //
///////////////////////////////////////////////////////////////

module mux2to1_reg_3st(clk,sel,ena,ain,bin,out);

input clk;
input sel;
input ena;
input [15:0] ain,bin;
output [15:0] out;

reg [15:0] out;

always @ (posedge clk)
begin
   if(ena)
      begin
         if (sel)
            out <= bin;
         else 
            out <= ain;
      end
   else
      out <= 16'hzzzz;
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// 3 to 1 MUX with parameterized width                       //
//                                                           //
///////////////////////////////////////////////////////////////

module mux3to1(sela,selb,selc,ain,bin,cin,out);
parameter width = 16; // Default data width in bits

input sela,selb,selc;
input [width-1:0] ain,bin,cin;
output [width-1:0] out;

reg [width-1:0] out;

always @ (sela or selb or selc or ain or bin or cin)
begin
   if (sela)
      out <= ain;
   else if(selb) 
      out <= bin;
   else if(selc) 
      out <= cin;
   else 
      out <= ain;
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// 3 to 1 MUX with registered output and parameterized width //
//                                                           //
///////////////////////////////////////////////////////////////

module mux3to1_reg(clk,sela,selb,selc,ain,bin,cin,out);
parameter width = 16; // Default data width in bits

input clk;
input sela,selb,selc;
input [width-1:0] ain,bin,cin;
output [width-1:0] out;

reg [width-1:0] out;

always @ (posedge clk)
begin
   if (sela)
      out <= ain;
   else if(selb) 
      out <= bin;
   else if(selc) 
      out <= cin;
   else 
      out <= ain;
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// 4 to 1 MUX with parameterized width                       //
//                                                           //
///////////////////////////////////////////////////////////////

module mux4to1(sel,ain,bin,cin,din,out);
parameter width = 16; // Default data width in bits

input [1:0] sel;
input [width-1:0] ain,bin,cin,din;
output [width-1:0] out;

reg [width-1:0] out;

always @ (sel or ain or bin or cin or din)
begin
   case (sel)
      2'd0:
         out <= ain;
      2'd1:
         out <= bin;
      2'd2:
         out <= cin;
      2'd3:
         out <= din;
      default:
         out <= ain;
   endcase
end
endmodule


///////////////////////////////////////////////////////////////
//                                                           //
// 8 to 1 MUX with parameterized width                       //
//                                                           //
///////////////////////////////////////////////////////////////

module mux8to1(sel,ain,bin,cin,din,ein,fin,gin,hin,out);
parameter width = 16; // Default data width in bits

input [2:0] sel;
input [width-1:0] ain,bin,cin,din,ein,fin,gin,hin;
output [width-1:0] out;

reg [width-1:0] out;

always @ (sel or ain or bin or cin or din or ein or fin or gin or hin)
begin
   case (sel)
      3'd0:
         out <= ain;
      3'd1:
         out <= bin;
      3'd2:
         out <= cin;
      3'd3:
         out <= din;
      3'd4:
         out <= ein;
      3'd5:
         out <= fin;
      3'd6:
         out <= gin;
      3'd7:
         out <= hin;
      default:
         out <= ain;
   endcase
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Three Deep Rotating Shift Register                        //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module shft_3_reg(c,s,l,d,q);
parameter width = 16; // Default data width in bits

input c;
input s;
input l;
input [width-1:0] d;
output [width-1:0] q;

reg [width-1:0] q;
reg [width-1:0] qa;
reg [width-1:0] qb;

always @ (posedge c)
begin
   if (s || l)
      if (l)
         begin
            qa <= d;
            qb <= qa;
            q <= qb;
         end
      else
         begin
            qa <= q;
            qb <= qa;
            q <= qb;
         end
   else
      begin
         qa <= qa;
         qb <= qb;
         q  <= q;
      end
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Four Deep Rotating Shift Register                         //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

module shft_4_reg(c,s,l,d,q);
parameter width = 16; // Default data width in bits

input c;
input s;
input l;
input [width-1:0] d;
output [width-1:0] q;

reg [width-1:0] q;
reg [width-1:0] qa;
reg [width-1:0] qb;
reg [width-1:0] qc;

always @ (posedge c)
begin
   if (s || l)
      if (l)
         begin
            qa <= d;
            qb <= qa;
            qc <= qb;
            q  <= qc;
         end
      else
         begin
            qa <= q;
            qb <= qa;
            qc <= qb;
            q  <= qc;
         end
   else
      begin
         qa <= qa;
         qb <= qb;
         qc <= qc;
         q  <= q;
      end
end
endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Three Deep Rotating Shift Register with 3-to-1 Mux        //
// parameterized width                                       //
//                                                           //
///////////////////////////////////////////////////////////////

//module shft_3_mux3to1(c,s,l,p,a,b,q);
//parameter width = 16; // Default data width in bits
//
//input c;
//input s;
//input l;
//input p;
//input [width-1:0] a,b;
//output [width-1:0] q;
//
//reg [width-1:0] q;
//reg [width-1:0] qa;
//reg [width-1:0] qb;
//
//always @ (posedge c)
//begin
//   if (s || l)
//      casex ({s,l,p})
//         3'b010:
//            begin
//               qa <= a;
//               qb <= qa;
//               q <= qb;
//            end
//         3'b011:
//            begin
//               qa <= b;
//               qb <= qa;
//               q <= qb;
//            end
//         3'b1xx:
//            begin
//               qa <= q;
//               qb <= qa;
//               q <= qb;
//            end
//         default:
//            begin
//               qa <= qa;
//               qb <= qb;
//               q  <= q;
//            end
//      endcase
//   else
//      begin
//         qa <= qa;
//         qb <= qb;
//         q  <= q;
//      end
//end
//
//endmodule

///////////////////////////////////////////////////////////////
//                                                           //
// Accumulator with parameterized width                      //
//                                                           //
///////////////////////////////////////////////////////////////

module accum(clk,clr,ce,in,out);
parameter in_width = 16; // Default input width in bits
parameter out_width = 24; // Default output width in bits

input clk;
input clr;
input ce;
input [in_width-1:0] in;
output [out_width-1:0] out;

reg [out_width-1:0] out;

always @ (posedge clk or posedge clr)
begin
   if (clr)
      out <= 0;
   else
      if (ce)
         out <= out + in;
      else
         out <= out;
end
endmodule
