`timescale 1ns / 1ps

module test_ports(CKIN_A, 
                  CKIN_B, 
                  CKIN_C, 
                  IN_A, 
                  IN_B, 
                  IN_C, 
                  CK_TPA, 
                  CK_TPB, 
                  CK_TPC, 
                  TEST_PORT_A, 
                  TEST_PORT_B, 
                  TEST_PORT_C);

    input CKIN_A;
    input CKIN_B;
    input CKIN_C;
    input [15:0] IN_A;
    input [15:0] IN_B;
    input [15:0] IN_C;
   output CK_TPA;
   output CK_TPB;
   output CK_TPC;
   output [15:0] TEST_PORT_A;
   output [15:0] TEST_PORT_B;
   output [15:0] TEST_PORT_C;
   
wire CK_TPA;
wire CK_TPB;
wire CK_TPC;
 reg [15:0] TEST_PORT_A;
 reg [15:0] TEST_PORT_B;
 reg [15:0] TEST_PORT_C;


// Instansiate the external clock drivers as double data rate output flip flops.

OFDDRRSE Ext_TPA_clk (.Q(CK_TPA),.C0(CKIN_A),.C1(!CKIN_A),.CE(1'b1),.D0(1'b0),.D1(1'b1),.R(1'b0),.S(1'b0));
OFDDRRSE Ext_TPB_clk (.Q(CK_TPB),.C0(CKIN_B),.C1(!CKIN_B),.CE(1'b1),.D0(1'b0),.D1(1'b1),.R(1'b0),.S(1'b0));
OFDDRRSE Ext_TPC_clk (.Q(CK_TPC),.C0(CKIN_C),.C1(!CKIN_C),.CE(1'b1),.D0(1'b0),.D1(1'b1),.R(1'b0),.S(1'b0));
   

always @(posedge CKIN_A)
begin
   TEST_PORT_A <= IN_A;
end

always @(posedge CKIN_B)
begin
   TEST_PORT_B <= IN_B;
end

always @(posedge CKIN_C)
begin
   TEST_PORT_C <= IN_C;
end

endmodule
