// Verilog model  - Fri Jun 11 11:04:55 2004

`timescale 1ns / 1ps
                            
module traffic_ctrl(CLK, POW_ON_RST, BTC_RST, ETH1_FRAME_READY, RX_STAT_MT, RCV_OPCODE, RCV_BUS_INOUT, TX_BUS_INOUT,
      FF_RHOLD, FF_WHOLD, FF_ODV, FF_FUNCT_DONE, FF_WRT_ERR, FF_RD_ERR, FF_RT_ERR, FF_MT_ERR, FF_MK_ERR, FF_TEST_MODE,
      V_RFUNCT, V_FF_READ, V_NORM_DAT, V_TXTYPE, V_SEND_NORM, V_PRIO_DAT, V_SEND_PRIO, V_SPONT_DAT, V_SEND_SPONT, VMEW_BR, VMER_BR,
      FL_INFF_AF, FL_BR, FL_ODV, FL_SND_PKT, FL_TXTYPE,
      CNFG_BR, CNFG_FUNCT_DONE, CNFG_RCV_ODV, CNFG_SND_PKT, CNFG_TX_VALDAT, CNFG_TXTYPE, 
      PREP4SHDWN, WARN_ON_SHDWN, SND_STRT_PKT,
      TXSTATUS, CLR_DCM_ERR, ENA_FRAME, LPBK1_EN,
      CNFG_RCV_ENA, CNFG_TX_ENA, CNFG_VALDAT, CNFG_FUNCT, CNFG_EXEC,
      FRAME_REQ, PRIO_DAT, SPONT_DAT, RX_STAT_ENA, RX_STAT_READ, RX_STAT_SEL,
      SND_NORM_NOW, SND_PRIO_NOW, SND_SPONT_NOW, TXTYPE, NORM_DAT, USR_LED_REG,
      BDR1_EN, BDR1_DIR, WFUNCT, RFUNCT, FF_OE, FF_READ, FF_VALDAT, TC_FF_ODV,
      V_FF_ODV, V_FF_RHOLD, VIN_CTRL_CODE, BTC_ST,
      RB_BG_CNFG, RB_BG_VMEW, FB_BG_VMEW, TB_BG_VMEW, TB_BG_VMER, TB_BG_CNFG, TB_BG_TC, TB_BG_FL,
      VMEW_OE, VMER_OE, TC_NORM_DAT, FL_VALDAT, FL_OE, FRC_RLD,
      TC_RDY4SHDWN, STRT_PKT_SENT);


    input CLK;
    input POW_ON_RST;
    input BTC_RST;
    input ETH1_FRAME_READY;
    input RX_STAT_MT;
    input [11:0] RCV_OPCODE;
    input [15:0] TXSTATUS;
    inout [15:0] RCV_BUS_INOUT;
    inout [15:0] TX_BUS_INOUT;
    input FF_RHOLD;
    input FF_WHOLD;
    input FF_ODV;
    input FF_FUNCT_DONE;
    input FF_WRT_ERR;
    input FF_RD_ERR;
    input FF_RT_ERR;
    input FF_MT_ERR;
    input FF_MK_ERR;
    input FF_TEST_MODE;
    input [2:0] V_RFUNCT;
    input V_FF_READ;
    input V_NORM_DAT;
    input [7:0] V_TXTYPE;
    input V_SEND_NORM;
    input V_PRIO_DAT;
    input V_SEND_PRIO;
    input V_SPONT_DAT;
    input V_SEND_SPONT;
    input [1:0] VMEW_BR;
    input VMER_BR;
    input FL_INFF_AF;
    input FL_BR;
    input FL_ODV;
    input FL_SND_PKT;
    input [7:0] FL_TXTYPE;
    input CNFG_RCV_ODV;
    input CNFG_SND_PKT;
    input CNFG_TX_VALDAT;
    input [7:0] CNFG_TXTYPE;
    input [1:0] CNFG_BR;
    input CNFG_FUNCT_DONE;
    input PREP4SHDWN;
    input WARN_ON_SHDWN;
    input SND_STRT_PKT;

   output CLR_DCM_ERR;
   output ENA_FRAME;
   output LPBK1_EN;
   output CNFG_RCV_ENA;
   output CNFG_TX_ENA;
   output CNFG_VALDAT;
   output [4:0]CNFG_FUNCT;
   output CNFG_EXEC;
   output FRAME_REQ;
   output PRIO_DAT;
   output SPONT_DAT;
   output RX_STAT_ENA;
   output RX_STAT_READ;
   output [2:0] RX_STAT_SEL;
   output SND_NORM_NOW;
   output SND_PRIO_NOW;
   output SND_SPONT_NOW;
   output [7:0] TXTYPE;
   output NORM_DAT;
   output [31:0] USR_LED_REG;
   output BDR1_EN;
   output BDR1_DIR;
   output [2:0] WFUNCT;
   output [2:0] RFUNCT;
   output FF_OE;
   output FF_READ;
   output FF_VALDAT;
   output TC_FF_ODV;
   output V_FF_ODV;
   output V_FF_RHOLD;
   output [2:0] VIN_CTRL_CODE;
   output [4:0] BTC_ST;
   output RB_BG_CNFG;
   output RB_BG_VMEW;
   output FB_BG_VMEW;
   output TB_BG_VMEW;
   output TB_BG_VMER;
   output TB_BG_CNFG;
   output TB_BG_TC;
   output TB_BG_FL;
   output VMEW_OE;
   output VMER_OE;
   output TC_NORM_DAT;
   output FL_VALDAT;
   output FL_OE;
   output FRC_RLD;
   output TC_RDY4SHDWN;
   output STRT_PKT_SENT;

reg [2:0] VIN_CTRL_CODE;
reg [7:0] TXTYPE;
reg [7:0] TC_TXTYPE;
reg [7:0] SP_TXTYPE;
reg [15:0] TX_BUS_REG;
reg [3:0] STATCNT;
reg [4:0] BTC_ST;
reg [3:0] RCVB_ST;
reg [2:0] FIFOB_ST;
reg [2:0] TRNSB_ST;
reg [1:0] BDR1_ST;
reg [3:0] TC_BR;
reg [3:0] OR_TC_BR;
reg [3:0] EX_TC_BR;
reg [4:0] CNFG_FUNCT;
reg CNFG_EXEC;
wire CNFG_VALDAT;
reg ANY_CNFG;
reg CNFG_WITH_DATA;
reg EN_SP_BR;
reg EN_EX_BR;
reg EN_OR_BR;
reg LD_SP_ERRS;
reg LD_SP_WARNS;
reg LD_SP_INFOS;

reg VD1,VD2;
reg CODE_RST;
reg CODE_ENA;
reg PRIO_REG;
reg SPONT_REG;
reg [7:0] FUNCT_REG;
reg RX_STAT_READ;
reg RX_STAT_ENA;
reg ENA_FRAME;
reg LPBK1_EN;
reg FRAME_REQ;
reg SPONT_DAT;
reg TC_SPONT_DAT;
reg PRIO_DAT;
reg TC_PRIO_DAT;
reg NORM_DAT;
reg TC_NORM_DAT;
reg SND_SPONT_NOW;
reg SND_PRIO_NOW;
reg SND_NORM_NOW;
reg TC_SND_SPONT_NOW;
reg TC_SND_PRIO_NOW;
reg TC_SND_NORM_NOW;
reg RSR1,RSR2,RSR3;
reg [2:0] RX_STAT_SEL;
reg [31:0] USR_LED_REG;
reg NWRD_CNTDWN;
reg NWRD_CNT_ENA;
wire NWRD_CNT_ENA_HIGH;
reg NWCE1;
reg LOAD_D1,LOAD_D2,LOAD_D3;
reg BDR1_EN;
reg BDR1_DIR;
reg BDR2FF;
reg BDR2RCV;
reg BDR1_RCV_ENA;
reg VMEW_OE;
reg BDR1_FF_ENA;
reg TC_OE;
reg VMER_OE;
reg CNFG_RCV_ENA;
reg CNFG_TX_ENA;
reg RB_BG_CNFG;
reg RB_BG_TC;
reg RB_BG_VMEW;
reg FB_BG_TC;
reg FB_BG_VMEW;
reg TB_BG_TC;
reg TB_BG_VMEW;
reg TB_BG_VMER;
reg TB_BG_CNFG;
reg TB_BG_FL;

reg [2:0] WFUNCT;
reg [2:0] RFUNCT;
reg FF_OE;
reg FF_READ;
reg [2:0] TC_RFUNCT;
reg TC_FF_READ;
reg TC_FF_ODV;
reg TC_FF_RHOLD;
reg V_FF_ODV;
reg V_FF_RHOLD;
reg FL_OE;
reg TC_RDY4SHDWN;
reg SET_CLRPND;
reg CLR_PNDG;
wire CLRPND_TMO;
reg [23:0]CLRPND_CNT;
reg STRT_PKT_SENT;

reg PP_in_FF;
reg RST_PP;
reg SET_SPONT;
reg LTNC_ST;
reg LTNC1,LTNC2,LTNC3,LTNC4,LTNC5,LTNC6;
reg LTNC7,LTNC8,LTNC9,LTNC10,LTNC11;

wire FRC_RLD;
wire CLR_DCM_ERR;
wire MIN_LTNC;
wire EXFF_LTNC;
wire VAL_DAT;
wire IMMEDIATE;
wire EOD;
wire [31:0] NWRD_REG;
wire [15:0] NWRD_CNT;
wire LOAD_USR_LED;
wire LOAD_NWRD_REG;
wire NORM_AF;
wire PRIO_AF;
reg  ALL_GRANTED;
reg [2:0] TC_ERRS;
reg [3:0] TC_WARNS;
reg [3:0] TC_INFOS;
reg OR_FUNCT_ONLY;
reg WAIT_FUNCT;
wire REQ_FUNCT_DONE;


`ifdef HEADER
`else
`include "header.v"                             
`endif

assign CLR_DCM_ERR = 0;
assign VAL_DAT = RCV_OPCODE[10];
assign IMMEDIATE = RCV_OPCODE[9];
assign EOD = RCV_OPCODE[8];
assign LOAD_USR_LED = LOAD_D2 && (FUNCT_REG == `Load_User_Reg);
assign LOAD_NWRD_REG = LOAD_D2 && ((FUNCT_REG == `Send_N_Words) || (FUNCT_REG == `Rd_Ext_FF) || (FUNCT_REG == `RT_Ext_FF));
assign FF_VALDAT = VAL_DAT && VD1 && ((FUNCT_REG == `VME_Cmds) || (FUNCT_REG == `VME_Cnfg) || (FUNCT_REG == `Wrt_Ext_FF) || (FUNCT_REG == `Prg_Ext_Off));   // should exclude first word.
assign FL_VALDAT = RB_BG_TC && VAL_DAT && VD1 && (FUNCT_REG == `Flash_R_W) || (CNFG_RCV_ENA && CNFG_RCV_ODV);   // should exclude first word.
assign CNFG_VALDAT = VAL_DAT && VD1 && CNFG_WITH_DATA;   // should exclude first word.
assign FRC_RLD = VAL_DAT && (FUNCT_REG == `Force_Reload);
assign RST_NWRD = LOAD_NWRD_REG || BTC_RST;
assign NORM_AF = TXSTATUS[6];
assign PRIO_AF = TXSTATUS[2];
assign TX_BUS_INOUT = TC_OE ? TX_BUS_REG : 16'hZZZZ;
assign MIN_LTNC = LTNC_ST & !LTNC3;
assign EXFF_LTNC = LTNC_ST & !LTNC11;
assign NWRD_CNT_ENA_HIGH = NWRD_CNT_ENA && (NWRD_REG[15:0] == 16'h0000);
assign REQ_FUNCT_DONE = FF_FUNCT_DONE || (CNFG_FUNCT_DONE && ANY_CNFG); // OR in other functions as needed
//assign REQ_FUNCT_DONE = FF_FUNCT_DONE || CNFG_FUNCT_DONE; // OR in other functions as needed

assign CLRPND_TMO = (CLRPND_CNT >= `Clr_Pndg_Time_Out);


defparam Send_N_Reg_Low.width = 16;
defparam Send_N_Reg_High.width = 16;
defparam N_word_cnt.width = 16;

cnt_dn_l  Send_N_Reg_Low (.clk(CLK),.dec(NWRD_CNT_ENA),.r(BTC_RST),.l(LOAD_NWRD_REG),.din(RCV_BUS_INOUT),.count(NWRD_REG[15:0]));
cnt_dn_l  Send_N_Reg_High (.clk(CLK),.dec(NWRD_CNT_ENA_HIGH),.r(BTC_RST),.l(LOAD_NWRD_REG),.din(TX_BUS_INOUT),.count(NWRD_REG[31:16]));
cnt_up    N_word_cnt (.clk(CLK),.inc(NWRD_CNT_ENA),.r(RST_NWRD),.count(NWRD_CNT));

always @(posedge CLK)
begin
   NWCE1 <= NWRD_CNT_ENA;
end

always @(posedge CLK)
begin
   if(BTC_ST == `TX_N_Words)
     TX_BUS_REG <= NWRD_CNT;
   else if (BTC_ST == `Load_Errs)
     TX_BUS_REG <= {8'h00,TC_ERRS,FF_WRT_ERR,FF_MK_ERR,FF_RT_ERR,FF_MT_ERR,FF_RD_ERR};
   else if (BTC_ST == `Load_Warns)
     TX_BUS_REG <= {12'h00,TC_WARNS};
   else if (BTC_ST == `Load_Infos)
     TX_BUS_REG <= {12'h00,TC_INFOS};
   else
     TX_BUS_REG <= TX_BUS_REG;
end

always @(posedge CLK or posedge BTC_RST)
begin: TC_errors
   if(BTC_RST)
      TC_ERRS <= `TC_No_Err;
   else
      case (BTC_ST)
         `EX_Req_Busses:
            if(ALL_GRANTED)
               case (FUNCT_REG)
                  `Read_Drop_Mem,`Read_WSOP_Mem,`Send_N_Words,
                  `Rdbk_Ext_Off,`Rd_Ext_Err_Cnts,`Rd_Ext_FF,`RT_Ext_FF,
                  `Save_Cnfg_Num,`Read_Cnfg_Num_Dir,`Read_Cnfg_Num_Dcd,`Rstr_Cnfg_Num, 
                  `Set_Cnfg_Dflt,`Read_Cnfg_Dflt, 
                  `Set_MACs,`Read_MACs_Dir,`Read_MACs_Dcd:
                     TC_ERRS <= `TC_No_Err;
                  default:
                     TC_ERRS <= `TC_Not_Exc;
               endcase
            else if(EX_TC_BR == `TC_NoOp)
               TC_ERRS <= `TC_Unk_Fnc;
            else
               TC_ERRS <= `TC_No_Err;
         `Send_Pkt:
            TC_ERRS <= `TC_No_Err;
         default:
            TC_ERRS <= TC_ERRS;
      endcase
end
always @(posedge CLK or posedge BTC_RST)
begin: TC_warnings
   if(BTC_RST)
      TC_WARNS <= `TC_No_Warn;
   else
      case (BTC_ST)
         `Wait_for_Buss_Req:
            if(PREP4SHDWN && WARN_ON_SHDWN)
               TC_WARNS <= `TC_Rld_Pndg;
            else
               TC_WARNS <= `TC_No_Warn;
         `Send_Pkt:
            TC_WARNS <= `TC_No_Warn;
         default:
            TC_WARNS <= TC_WARNS;
      endcase
end
always @(posedge CLK or posedge BTC_RST)
begin: TC_information
   if(BTC_RST)
      TC_INFOS <= `TC_No_Info;
   else
      case (BTC_ST)
         `Wait_for_Buss_Req:
            if(SND_STRT_PKT)
               TC_INFOS <= `TC_Start_up;
            else
               TC_INFOS <= `TC_No_Info;
         `Send_Pkt:
            TC_INFOS <= `TC_No_Info;
         default:
            TC_INFOS <= TC_INFOS;
      endcase
end


always @(posedge CLK)
begin
   if(BTC_RST)
     USR_LED_REG <= 32'h00000000;
   else if(LOAD_USR_LED)
     USR_LED_REG <= {TX_BUS_INOUT,RCV_BUS_INOUT};
   else
     USR_LED_REG <= USR_LED_REG;
//USR_LED_REG <= {FUNCT_REG check size,CODE_ENA,EN_OR_BR,EN_EX_BR,ALL_GRANTED,FRAME_REQ,ETH1_FRAME_READY,BTC_ST};
//USR_LED_REG <= {RFUNCT,2'b00,RCVB_ST,FIFOB_ST,TRNSB_ST,BDR1_ST};
//USR_LED_REG <= {RCVB_ST,TRNSB_ST,BDR1_ST,ENA_FRAME,LPBK1_EN,BDR1_EN,BDR1_DIR,FF_OE,FF_READ,FF_VALDAT,NORM_DAT};
end



always @(posedge CLK)
begin
   VD1 <= VAL_DAT || TC_FF_ODV;
   VD2 <= VD1;
end


always @(posedge CLK)
begin
   LOAD_D1 <= VAL_DAT && (BTC_ST == `Wait_for_Valid_Data);
   LOAD_D2 <= LOAD_D1;
   LOAD_D3 <= LOAD_D2;
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      begin
         PRIO_REG <= 1'b0;
         FUNCT_REG <= 8'h00;
      end
   else
      if(CODE_ENA)
         begin
            PRIO_REG <= IMMEDIATE;
            FUNCT_REG <= RCV_OPCODE[7:0];
         end
      else if(CODE_RST)
         begin
            PRIO_REG <= 1'b0;
            FUNCT_REG <= 8'h00;
         end
      else
         begin
            PRIO_REG <= PRIO_REG;
            FUNCT_REG <= FUNCT_REG;
         end
end
always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      SPONT_REG <= 1'b0;
   else
      if(SET_SPONT)
         SPONT_REG <= 1;
      else if(CODE_RST)
         SPONT_REG <= 0;
      else
         SPONT_REG <= SPONT_REG;
end


always @(posedge CLK)
begin
   RSR1 <= RX_STAT_READ;
   RSR2 <= RSR1;
   RSR3 <= RSR2;
end

always @(posedge CLK)
begin
   case(FUNCT_REG)
      `Read_Drop_Mem:
         RX_STAT_SEL <= 3'o0;
      `Read_WSOP_Mem:
         RX_STAT_SEL <= 3'o1;
      default:
         RX_STAT_SEL <= 3'o0;
   endcase
end

always @(posedge CLK)
begin
   if(CODE_RST || BTC_RST)
      STATCNT <= 4'h0;
   else
      if(RX_STAT_READ)
         STATCNT <= STATCNT + 1;
      else
         STATCNT <= STATCNT;
end

always @(posedge CLK or posedge BTC_RST)
begin: PP_in_FF_SR
   if(BTC_RST)
      PP_in_FF <= 0;
   else
      if (TC_NORM_DAT || TC_PRIO_DAT)
         PP_in_FF <= 1;
      else if (RST_PP)
         PP_in_FF <= 0;
      else
         PP_in_FF <= PP_in_FF;
end

//always @(posedge CLK or posedge BTC_RST)
//begin
//   if(BTC_RST)
//      FF_ECC_ENA <= 0;
//   else
//      case(FUNCT_REG)
//         `ECC_enable:
//            FF_ECC_ENA <= 1;
//         `ECC_disable:
//            FF_ECC_ENA <= 0;
//         default:
//            FF_ECC_ENA <= FF_ECC_ENA;
//      endcase
//end
//
//always @(posedge CLK or posedge BTC_RST)
//begin
//   if(BTC_RST)
//      FF_TEST_MODE <= 0;
//   else
//      case(FUNCT_REG)
//         `Set_FF_Test:
//            FF_TEST_MODE <= 1;
//         `Set_FF_VME:
//            FF_TEST_MODE <= 0;
//         default:
//            FF_TEST_MODE <= FF_TEST_MODE;
//      endcase
//end
//always @(posedge CLK or posedge BTC_RST)
//begin
//   if(BTC_RST)
//      INJ_ERRS <= 0;
//   else
//      case(FUNCT_REG)
//         `Set_Inj_Err:
//            INJ_ERRS <= 1;
//         `Rst_Inj_Err:
//            INJ_ERRS <= 0;
//         default:
//            INJ_ERRS <= INJ_ERRS;
//      endcase
//end
//always @(posedge CLK or posedge BTC_RST)
//begin
//   if(BTC_RST)
//      WARN_ON_SHDWN <= 0;
//   else
//      case(FUNCT_REG)
//         `Warn_On_Shdwn:
//            WARN_ON_SHDWN <= 1;
//         `No_Warn_On_Shdwn:
//            WARN_ON_SHDWN <= 0;
//         default:
//            WARN_ON_SHDWN <= WARN_ON_SHDWN;
//      endcase
//end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      CLR_PNDG <= 0;
   else
      if(SET_CLRPND)
         CLR_PNDG <= 1;
      else
         CLR_PNDG <= CLR_PNDG;
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      CLRPND_CNT <= 24'h000000;
   else
      if(CLR_PNDG && !CLRPND_TMO)
         CLRPND_CNT <= CLRPND_CNT + 1;
      else
         CLRPND_CNT <= CLRPND_CNT;
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      CNFG_FUNCT <= 4'h0;
   else
      if(ANY_CNFG)
         CNFG_FUNCT <= FUNCT_REG[4:0];
      else
         CNFG_FUNCT <= 4'h0;
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      ANY_CNFG <= 0;
   else
      case(FUNCT_REG)
         `Set_FF_Test,`Set_FF_VME,`ECC_enable,`ECC_disable, 
         `Save_Cnfg_Num,`Read_Cnfg_Num_Dir,`Read_Cnfg_Num_Dcd,`Rstr_Cnfg_Num, 
         `Set_Cnfg_Dflt,`Read_Cnfg_Dflt, 
         `Set_MACs,`Read_MACs_Dir,`Read_MACs_Dcd,`Read_CRs, 
         `Wrt_Eth_CR,`Wrt_Ext_CR,`Wrt_Rst_CR,`Wrt_VME_CR, 
         `Wrt_BTO_CR,`Wrt_BGTO_CR,`Wrt_All_CRs,`Set_Clr_CRs,
         `Set_Inj_Err,`Rst_Inj_Err,
         `Warn_On_Shdwn, `No_Warn_On_Shdwn,
         `Snd_Startup_Pkt, `No_Startup_Pkt:
            ANY_CNFG <= 1;
         default:
            ANY_CNFG <= 0;
      endcase
end
always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      CNFG_WITH_DATA <= 0;
   else
      case(FUNCT_REG)
         `Save_Cnfg_Num,`Read_Cnfg_Num_Dir,`Read_Cnfg_Num_Dcd,`Rstr_Cnfg_Num, 
         `Set_Cnfg_Dflt,`Set_MACs, 
         `Wrt_Eth_CR,`Wrt_Ext_CR,`Wrt_Rst_CR,`Wrt_VME_CR, 
         `Wrt_BTO_CR,`Wrt_BGTO_CR,`Wrt_All_CRs,`Set_Clr_CRs:
            CNFG_WITH_DATA <= 1;
         default:
            CNFG_WITH_DATA <= 0;
      endcase
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      WAIT_FUNCT <= 0;
   else
      case(FUNCT_REG)
         `Prg_Ext_Off, `MRst_Ext_FF, `PRst_Ext_FF,
         `Set_FF_Test, `Set_FF_VME, `ECC_enable, `ECC_disable,
         `Wrt_Eth_CR, `Wrt_Ext_CR, `Wrt_Rst_CR, `Wrt_VME_CR,
         `Wrt_BTO_CR, `Wrt_BGTO_CR, `Wrt_All_CRs, `Set_Clr_CRs,
         `Set_Inj_Err,`Rst_Inj_Err,
         `Warn_On_Shdwn, `No_Warn_On_Shdwn,
         `Snd_Startup_Pkt, `No_Startup_Pkt:
            WAIT_FUNCT <= 1;
         default:
            WAIT_FUNCT <= 0;
      endcase
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      OR_FUNCT_ONLY <= 0;
   else
      case(FUNCT_REG)
         `Force_Reload,`VME_Cmds, `VME_Cnfg, `Wrt_Ext_FF, `ST_MK_Ext_FF, `RST_MK_Ext_FF,
         `Load_User_Reg, `MRst_Ext_FF, `PRst_Ext_FF, `Rst_Ext_Err_Cnt, `Prg_Ext_Off, `Flash_R_W,
         `Set_FF_Test, `Set_FF_VME, `ECC_enable, `ECC_disable,`Read_CRs,
         `Wrt_Eth_CR, `Wrt_Ext_CR, `Wrt_Rst_CR, `Wrt_VME_CR,
         `Wrt_BTO_CR, `Wrt_BGTO_CR, `Wrt_All_CRs, `Set_Clr_CRs,
         `Set_Inj_Err,`Rst_Inj_Err,
         `Warn_On_Shdwn, `No_Warn_On_Shdwn,
         `Snd_Startup_Pkt, `No_Startup_Pkt:
            OR_FUNCT_ONLY <= 1;
         default:
            OR_FUNCT_ONLY <= 0;
      endcase
end

always @(FUNCT_REG)
begin
   case (FUNCT_REG)
      `MRst_Ext_FF:
         WFUNCT <= `MRst_FF;
      `PRst_Ext_FF:
         WFUNCT <= `PRst_FF;
      `Wrt_Ext_FF,`VME_Cmds:
         WFUNCT <= `Wrt_FF;
      `Prg_Ext_Off:
         WFUNCT <= `Prg_Offsets;
      `Rst_Ext_Err_Cnt:
         WFUNCT <= `Rst_Err_Cnts;
      default:
         WFUNCT <= `WNoOp;
   endcase
   case (FUNCT_REG)
      `Rd_Ext_FF:
         TC_RFUNCT <= `Rd_FF;
      `RT_Ext_FF:
         TC_RFUNCT <= `RT_FF;
      `ST_MK_Ext_FF:
         TC_RFUNCT <= `SET_MK_FF;
      `RST_MK_Ext_FF:
         TC_RFUNCT <= `RST_MK_FF;
      `Rdbk_Ext_Off:
         TC_RFUNCT <= `Rdbk_Offsets;
      `Rd_Ext_Err_Cnts:
         TC_RFUNCT <= `Rd_Err_Cnts;
      default:
         TC_RFUNCT <= `RNoOp;
   endcase
end

always @(posedge CLK or posedge POW_ON_RST)
begin: Receive_Buss_Ctrl_FSM
   if(POW_ON_RST)
      RCVB_ST <= `RB_Free;
   else
      case(RCVB_ST)
         `RB_Free:
            if((TC_BR==`Rd_Eth_FIFO) || (TC_BR==`Lpback) || (TC_BR==`Direct_VME))
               RCVB_ST  <= `TWE_RB;
            else if(TC_BR==`TC_Cnfg_Store)
               RCVB_ST  <= `TWC_RB;
            else if(CNFG_BR==`Cnfg_Store)
               RCVB_ST  <= `CWC_RB;
            else if(TC_BR==`Rd_RX_STAT)
               RCVB_ST  <= `TWS_RB;
            else if(TC_BR==`Rd_Ext_FIFO)
               RCVB_ST  <= `Get1_BDR_RB;
            else if(VMEW_BR==`VME_cnfg_save)
               RCVB_ST  <= `Get2_BDR_RB;
            else
               RCVB_ST  <= `RB_Free;
         `TWE_RB:
            if(TC_BR==`TC_NoOp)
               RCVB_ST  <= `RB_Free;
            else
               RCVB_ST  <= `TWE_RB;
         `TWC_RB:
            if(TC_BR==`TC_NoOp)
               RCVB_ST  <= `RB_Free;
            else
               RCVB_ST  <= `TWC_RB;
         `CWC_RB:
            if(CNFG_BR==`Cnfg_NoOp)
               RCVB_ST  <= `RB_Free;
            else
               RCVB_ST  <= `CWC_RB;
         `TWS_RB:
            if(TC_BR==`TC_NoOp)
               RCVB_ST  <= `RB_Free;
            else
               RCVB_ST  <= `TWS_RB;
         `Get1_BDR_RB:
            if(TC_BR==`TC_NoOp)
               RCVB_ST  <= `RB_Free;
            else if(BDR2RCV)
               RCVB_ST  <= `TWB_RB;
            else
               RCVB_ST  <= `Get1_BDR_RB;
         `TWB_RB:
            if(TC_BR==`TC_NoOp)
               RCVB_ST  <= `RB_Free;
            else
               RCVB_ST  <= `TWB_RB;
         `Get2_BDR_RB:
            if(VMEW_BR==`VMEW_NoOp)
               RCVB_ST  <= `RB_Free;
            else if(BDR2RCV)
               RCVB_ST  <= `VWWB_RB;
            else
               RCVB_ST  <= `Get2_BDR_RB;
         `VWWB_RB:
            if(VMEW_BR==`VMEW_NoOp)
               RCVB_ST  <= `RB_Free;
            else
               RCVB_ST  <= `VWWB_RB;
         default:
               RCVB_ST  <= `RB_Free;
      endcase
end
always @(RCVB_ST)
begin
   case (RCVB_ST)
      `RB_Free:
         begin
            ENA_FRAME <= 1;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 0;
            RB_BG_TC <= 0;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `TWE_RB:
         begin
            ENA_FRAME <= 1;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 0;
            RB_BG_TC <= 1;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `TWC_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 1;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 0;
            RB_BG_TC <= 1;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `CWC_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 1;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 0;
            RB_BG_TC <= 0;
            RB_BG_CNFG <= 1;
            RB_BG_VMEW <= 0;
         end
      `TWS_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 1;
            BDR1_RCV_ENA <= 0;
            RB_BG_TC <= 1;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `Get1_BDR_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 1;
            RB_BG_TC <= 0;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `TWB_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 1;
            RB_BG_TC <= 1;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `Get2_BDR_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 1;
            RB_BG_TC <= 0;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
      `VWWB_RB:
         begin
            ENA_FRAME <= 0;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 1;
            RB_BG_TC <= 0;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 1;
         end
      default:
         begin
            ENA_FRAME <= 1;
            CNFG_RCV_ENA <= 0;
            RX_STAT_ENA <= 0;
            BDR1_RCV_ENA <= 0;
            RB_BG_TC <= 0;
            RB_BG_CNFG <= 0;
            RB_BG_VMEW <= 0;
         end
   endcase
end

always @(posedge CLK or posedge POW_ON_RST)
begin: FIFO_Buss_Ctrl_FSM
   if(POW_ON_RST)
      FIFOB_ST <= `FB_Free;
   else
      case(FIFOB_ST)
         `FB_Free:
            if(TC_BR==`Rd_Ext_FIFO)
               FIFOB_ST  <= `TWF_FB;
            else if(TC_BR==`Direct_VME)
               FIFOB_ST  <= `Get_BDR_FB;
            else if(VMEW_BR==`VME_fr_FIFO)
               FIFOB_ST  <= `VWWF_FB;
            else if(VMEW_BR==`VME_cnfg_save)
               FIFOB_ST  <= `VWWV_FB;
            else
               FIFOB_ST  <= `FB_Free;
         `TWF_FB:
            if(TC_BR==`TC_NoOp)
               FIFOB_ST  <= `FB_Free;
            else
               FIFOB_ST  <= `TWF_FB;
         `Get_BDR_FB:
            if(TC_BR==`TC_NoOp)
               FIFOB_ST  <= `FB_Free;
            else if(BDR2FF)
               FIFOB_ST  <= `TWB_FB;
            else
               FIFOB_ST  <= `Get_BDR_FB;
         `TWB_FB:
            if(TC_BR==`TC_NoOp)
               FIFOB_ST  <= `FB_Free;
            else
               FIFOB_ST  <= `TWB_FB;
         `VWWF_FB:
            if(VMEW_BR==`VMEW_NoOp)
               FIFOB_ST  <= `FB_Free;
            else
               FIFOB_ST  <= `VWWF_FB;
         `VWWV_FB:
            if(VMEW_BR==`VMEW_NoOp)
               FIFOB_ST  <= `FB_Free;
            else
               FIFOB_ST  <= `VWWV_FB;
         default:
               FIFOB_ST  <= `FB_Free;
      endcase
end
always @(FIFOB_ST)
begin
   case (FIFOB_ST)
      `FB_Free:
         begin
            FF_OE <= 1;
            VMEW_OE <= 0;
            BDR1_FF_ENA <= 0;
            FB_BG_TC <= 0;
            FB_BG_VMEW <= 0;
         end
      `TWF_FB:
         begin
            FF_OE <= 1;
            VMEW_OE <= 0;
            BDR1_FF_ENA <= 0;
            FB_BG_TC <= 1;
            FB_BG_VMEW <= 0;
         end
      `Get_BDR_FB:
         begin
            FF_OE <= 0;
            VMEW_OE <= 0;
            BDR1_FF_ENA <= 1;
            FB_BG_TC <= 0;
            FB_BG_VMEW <= 0;
         end
      `TWB_FB:
         begin
            FF_OE <= 0;
            VMEW_OE <= 0;
            BDR1_FF_ENA <= 1;
            FB_BG_TC <= 1;
            FB_BG_VMEW <= 0;
         end
      `VWWF_FB:
         begin
            FF_OE <= 1;
            VMEW_OE <= 0;
            BDR1_FF_ENA <= 0;
            FB_BG_TC <= 0;
            FB_BG_VMEW <= 1;
         end
      `VWWV_FB:
         begin
            FF_OE <= 0;
            VMEW_OE <= 1;
            BDR1_FF_ENA <= 0;
            FB_BG_TC <= 0;
            FB_BG_VMEW <= 1;
         end
      default:
         begin
            FF_OE <= 1;
            VMEW_OE <= 0;
            BDR1_FF_ENA <= 0;
            FB_BG_TC <= 0;
            FB_BG_VMEW <= 0;
         end
   endcase
end



always @(posedge CLK or posedge POW_ON_RST)
begin: Transmit_Buss_Ctrl_FSM
   if(POW_ON_RST)
      TRNSB_ST <= `TB_Free;
   else
      case(TRNSB_ST)
         `TB_Free:
            if((TC_BR==`Lpback) || (TC_BR==`Rd_RX_STAT) || (TC_BR==`Rd_Ext_FIFO))
               TRNSB_ST  <= `TWL_TB;
            else if(TC_BR==`Rd_Curr_Cnfg)
               TRNSB_ST  <= `TWC_TB;
            else if(CNFG_BR==`Cnfg_Xmit)
               TRNSB_ST  <= `CWC_TB;
            else if(TC_BR==`Spont_Rpt)
               TRNSB_ST  <= `TWT_TB;
            else if(VMEW_BR==`VME_cnfg_save)
               TRNSB_ST  <= `VWWL_TB;
            else if(VMER_BR==`VME_Output)
               TRNSB_ST  <= `VRWV_TB;
            else if(FL_BR==`FL_Output)
               TRNSB_ST  <= `FLWFL_TB;
            else
               TRNSB_ST  <= `TB_Free;
         `TWL_TB:
            if(TC_BR==`TC_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `TWL_TB;
         `TWC_TB:
            if(TC_BR==`TC_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `TWC_TB;
         `CWC_TB:
            if(CNFG_BR==`Cnfg_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `CWC_TB;
         `TWT_TB:
            if(TC_BR==`TC_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `TWT_TB;
         `VWWL_TB:
            if(VMEW_BR==`VMEW_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `VWWL_TB;
         `VRWV_TB:
            if(VMER_BR==`VMER_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `VRWV_TB;
         `FLWFL_TB:
            if(FL_BR==`FL_NoOp)
               TRNSB_ST  <= `TB_Free;
            else
               TRNSB_ST  <= `FLWFL_TB;
         default:
               TRNSB_ST  <= `TB_Free;
      endcase
end
always @(TRNSB_ST)
begin
   case (TRNSB_ST)
      `TB_Free:
         begin
            TC_OE <= 0;
            VMER_OE <= 1;
            LPBK1_EN <= 0;
            FL_OE <= 0;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 0;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
      `TWL_TB:
         begin
            TC_OE <= 0;
            VMER_OE <= 0;
            LPBK1_EN <= 1;
            FL_OE <= 0;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 1;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
      `TWC_TB:
         begin
            TC_OE <= 0;
            VMER_OE <= 0;
            LPBK1_EN <= 0;
            FL_OE <= 0;
            CNFG_TX_ENA <= 1;
            TB_BG_TC <= 1;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
      `CWC_TB:
         begin
            TC_OE <= 0;
            VMER_OE <= 0;
            LPBK1_EN <= 0;
            FL_OE <= 0;
            CNFG_TX_ENA <= 1;
            TB_BG_TC <= 0;
            TB_BG_CNFG <= 1;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
      `TWT_TB:
         begin
            TC_OE <= 1;
            VMER_OE <= 0;
            LPBK1_EN <= 0;
            FL_OE <= 0;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 1;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
      `VWWL_TB:
         begin
            TC_OE <= 0;
            VMER_OE <= 0;
            LPBK1_EN <= 1;
            FL_OE <= 0;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 0;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 1;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
      `VRWV_TB:
         begin
            TC_OE <= 0;
            VMER_OE <= 1;
            LPBK1_EN <= 0;
            FL_OE <= 0;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 0;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 1;
            TB_BG_FL <= 0;
         end
      `FLWFL_TB:
         begin
            TC_OE <= 0;
            VMER_OE <= 0;
            LPBK1_EN <= 0;
            FL_OE <= 1;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 0;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 1;
         end
      default:
         begin
            TC_OE <= 0;
            VMER_OE <= 1;
            LPBK1_EN <= 0;
            FL_OE <= 0;
            CNFG_TX_ENA <= 0;
            TB_BG_TC <= 0;
            TB_BG_CNFG <= 0;
            TB_BG_VMEW <= 0;
            TB_BG_VMER <= 0;
            TB_BG_FL <= 0;
         end
   endcase
end


always @(posedge CLK or posedge POW_ON_RST)
begin: BDR1_Ctrl_FSM
   if(POW_ON_RST)
      BDR1_ST <= `Disabled;
   else
      case(BDR1_ST)
         `Disabled:
            if(BDR1_FF_ENA)
               BDR1_ST  <= `To_FF_Bus;
            else if(BDR1_RCV_ENA)
               BDR1_ST  <= `To_RCV_Bus;
            else
               BDR1_ST  <= `Disabled;
         `To_FF_Bus:
            if(!BDR1_FF_ENA && !BDR1_RCV_ENA)
               BDR1_ST  <= `Disabled;
            else if(!BDR1_FF_ENA && BDR1_RCV_ENA)
               BDR1_ST  <= `To_RCV_Bus;
            else
               BDR1_ST  <= `To_FF_Bus;
         `To_RCV_Bus:
            if(!BDR1_FF_ENA && !BDR1_RCV_ENA)
               BDR1_ST  <= `Disabled;
            else if(BDR1_FF_ENA && !BDR1_RCV_ENA)
               BDR1_ST  <= `To_FF_Bus;
            else
               BDR1_ST  <= `To_RCV_Bus;
         default:
               BDR1_ST  <= `Disabled;
      endcase
end

always @(BDR1_ST)
begin
   case (BDR1_ST)
      `Disabled:
         begin
            BDR1_DIR <= 0;
            BDR1_EN <= 0;
            BDR2FF <= 0;
            BDR2RCV <= 0;
         end
      `To_FF_Bus:
         begin
            BDR1_DIR <= 0;
            BDR1_EN <= 1;
            BDR2FF <= 1;
            BDR2RCV <= 0;
         end
      `To_RCV_Bus:
         begin
            BDR1_DIR <= 1;
            BDR1_EN <= 1;
            BDR2FF <= 0;
            BDR2RCV <= 1;
         end
      default:
         begin
            BDR1_DIR <= 0;
            BDR1_EN <= 0;
            BDR2FF <= 0;
            BDR2RCV <= 0;
         end
   endcase
end

always @(TC_BR or RB_BG_TC or FB_BG_TC or TB_BG_TC)
begin
   case(TC_BR)
      `TC_NoOp:
         ALL_GRANTED <= 0;
      `Rd_Eth_FIFO:
         ALL_GRANTED <= RB_BG_TC;
      `Lpback:
         ALL_GRANTED <= RB_BG_TC             && TB_BG_TC;
      `Rd_RX_STAT:
         ALL_GRANTED <= RB_BG_TC             && TB_BG_TC;
      `Rd_Ext_FIFO:
         ALL_GRANTED <= RB_BG_TC && FB_BG_TC && TB_BG_TC;
      `Direct_VME:
         ALL_GRANTED <= RB_BG_TC && FB_BG_TC;
      `Spont_Rpt:
         ALL_GRANTED <=                         TB_BG_TC;
      `TC_Cnfg_Store:
         ALL_GRANTED <= RB_BG_TC;
      `Rd_Curr_Cnfg:
         ALL_GRANTED <=                         TB_BG_TC;
      default:
         ALL_GRANTED <= 0;
   endcase
end

always @(posedge CLK or posedge BTC_RST)
begin: Buss_Traffic_FSM
   if(BTC_RST)
      BTC_ST <= `Wait_for_Buss_Req;
   else
      case(BTC_ST)
         `Wait_for_Buss_Req:
            begin
               if(SND_STRT_PKT)
                  BTC_ST <= `Load_Infos;
               else
                  if(!PREP4SHDWN || (CLR_PNDG && !CLRPND_TMO))   //Normal processing
                     if(ETH1_FRAME_READY)
                        BTC_ST <= `Get_Op_Code;
                     else if(FUNCT_REG != 8'h00) 
                        BTC_ST <= `EX_Req_Busses;
                     else
                        BTC_ST <= `Wait_for_Buss_Req;
                  else if(CLRPND_TMO)                // Timed out waiting for pending transactions
                     BTC_ST <= `TC_Rdy4Shd;
                  else if(WARN_ON_SHDWN)             // Send warning of pending shutdown
                     BTC_ST <= `Load_Warns;
                  else                               // Don't send warning but clear pending transactions
                     BTC_ST <= `TC_Clr_Pndg;
            end
         `Get_Op_Code:
            BTC_ST <= `OR_Req_Busses;
         `OR_Req_Busses:
            begin
               if(ALL_GRANTED)
                  BTC_ST <= `Wait_for_Valid_Data;
               else
                  BTC_ST <= `OR_Req_Busses;
            end
         `EX_Req_Busses:
            begin
               if(ALL_GRANTED)
                  case (FUNCT_REG)
                     `Read_Drop_Mem,`Read_WSOP_Mem:
                        BTC_ST <= `Get_RX_Stat_Info;
                     `Send_N_Words:
                        BTC_ST <= `TX_N_Words;
                     `Rdbk_Ext_Off,`Rd_Ext_Err_Cnts:
                        BTC_ST <= `R_X_FF_Off_EC;
                     `Rd_Ext_FF,`RT_Ext_FF:
                        BTC_ST <= `Read_X_FF;
                     `Save_Cnfg_Num,`Read_Cnfg_Num_Dir,`Read_Cnfg_Num_Dcd,`Rstr_Cnfg_Num, 
                     `Set_Cnfg_Dflt,`Read_Cnfg_Dflt, 
                     `Set_MACs,`Read_MACs_Dir,`Read_MACs_Dcd:
                        BTC_ST <= `Cnfg2Flash;
                     default:
                        BTC_ST <= `Clr_Funct_Reg;
                  endcase
               else if(EX_TC_BR == `TC_NoOp)
                  BTC_ST <= `Clr_Funct_Reg;
               else
                  BTC_ST <= `EX_Req_Busses;
            end
         `Wait_for_Valid_Data:
            begin
               if(VAL_DAT && (FUNCT_REG == `Loopback))
                  BTC_ST <= `Lp_Back_Data;
               else if(VAL_DAT && (FUNCT_REG != `Loopback))
                  BTC_ST <= `Wait_for_EOD;
               else
                  BTC_ST <= `Wait_for_Valid_Data;
            end
         `Lp_Back_Data:
            begin
               if(EOD)
                  BTC_ST <= `Send_Pkt;
               else
                  BTC_ST <= `Lp_Back_Data;
            end
         `Wait_for_EOD:
            begin
               if(EOD)
                  if(OR_FUNCT_ONLY && WAIT_FUNCT)
                     BTC_ST <= `Wait_for_Done;
                  else if(OR_FUNCT_ONLY && !WAIT_FUNCT)
                     BTC_ST <= `Clr_Funct_Reg;
                  else
                     BTC_ST <= `Rmv_BR;
               else
                  BTC_ST <= `Wait_for_EOD;
            end
         `Wait_for_Done:
            begin
               if(REQ_FUNCT_DONE)
                  BTC_ST <= `Clr_Funct_Reg;
               else
                  BTC_ST <= `Wait_for_Done;
            end
         `Rmv_BR:
            begin
               if(TC_BR == `TC_NoOp)
                  BTC_ST <= `EX_Req_Busses;
               else
                  BTC_ST <= `Rmv_BR;
            end
         `Clr_Funct_Reg:
            begin
               if(FF_MK_ERR || FF_WRT_ERR || (TC_ERRS != `TC_No_Err))
                  BTC_ST <= `Load_Errs;
               else
                  BTC_ST <= `Wait_for_Buss_Req;
            end
         `Get_RX_Stat_Info:
            begin
               if(!(!RX_STAT_MT || TC_NORM_DAT || TC_PRIO_DAT))
                  BTC_ST <= `Send_Pkt;
               else
                  BTC_ST <= `Get_RX_Stat_Info;
            end
         `TX_N_Words:
            begin
               if(!(MIN_LTNC || NWRD_CNTDWN || TC_NORM_DAT || TC_PRIO_DAT))
                  BTC_ST <= `Send_Pkt;
               else
                  BTC_ST <= `TX_N_Words;
            end
         `R_X_FF_Off_EC:
            begin
               if(FF_FUNCT_DONE && !TC_NORM_DAT && !TC_PRIO_DAT)
                  BTC_ST <= `Send_Pkt;
               else
                  BTC_ST <= `R_X_FF_Off_EC;
            end
         `Cnfg2Flash:
            begin
               if(CNFG_FUNCT_DONE)
                  BTC_ST <= `Clr_Funct_Reg;
               else
                  BTC_ST <= `Cnfg2Flash;
            end
         `Read_X_FF:
            begin
               if((FF_RD_ERR || FF_RT_ERR || FF_MT_ERR || !NWRD_CNTDWN) && !EXFF_LTNC && !TC_NORM_DAT && !TC_PRIO_DAT)
                  BTC_ST <= `Rd_Done;
               else
                  BTC_ST <= `Read_X_FF;
            end
         `Rd_Done:
            begin
               if((FUNCT_REG == `Rd_Ext_FF || FUNCT_REG == `RT_Ext_FF) && (FF_RD_ERR || FF_RT_ERR || FF_MT_ERR))
                  if(PP_in_FF)
                    BTC_ST <= `Send_PP;
                  else
                    BTC_ST <= `Load_Errs;
               else
                  BTC_ST <= `Send_Pkt;
            end
         `Send_PP:
            BTC_ST <= `Load_Errs;
         `Load_Errs:
            BTC_ST <= `Spnt_Req_Busses;
         `Load_Warns:
            BTC_ST <= `Spnt_Req_Busses;
         `Load_Infos:
            BTC_ST <= `Spnt_Req_Busses;
         `Spnt_Req_Busses:
            begin
               if(ALL_GRANTED)
                  BTC_ST <= `TX_Spnt_Pkt;
               else
                  BTC_ST <= `Spnt_Req_Busses;
            end
         `TX_Spnt_Pkt:
            BTC_ST <= `Ins_Gap;
         `Ins_Gap:
            BTC_ST <= `Send_Pkt;
         `Send_Pkt:
            if(PREP4SHDWN && !CLR_PNDG && WARN_ON_SHDWN)
               BTC_ST <= `TC_Clr_Pndg;
            else
               BTC_ST <= `Wait_for_Buss_Req;
         `TC_Clr_Pndg:
            BTC_ST <= `Wait_for_Buss_Req;
         `TC_Rdy4Shd:
            BTC_ST <= `TC_Rdy4Shd;
         default:
            BTC_ST <= `Wait_for_Buss_Req;
      endcase
end

always @(BTC_ST)
begin
   case(BTC_ST)
      `Cnfg2Flash:
         CNFG_EXEC <= 1;
      default:
         CNFG_EXEC <= 0;
   endcase
end

always @(BTC_ST)
begin
   case (BTC_ST)
      `TC_Clr_Pndg:
         begin
            TC_RDY4SHDWN <= 0;
            SET_CLRPND <= 1;
         end
      `TC_Rdy4Shd:
         begin
            TC_RDY4SHDWN <= 1;
            SET_CLRPND <= 0;
         end
      default:
         begin
            TC_RDY4SHDWN <= 0;
            SET_CLRPND <= 0;
         end
   endcase
end

always @(BTC_ST or SND_STRT_PKT)
begin
   case (BTC_ST)
      `Get_Op_Code:
          begin
             CODE_RST <= 0;
             CODE_ENA <= 1;
             STRT_PKT_SENT <= 0;
          end
      `Wait_for_Valid_Data:
          begin
             CODE_RST <= 0;
             CODE_ENA <= 0;
             STRT_PKT_SENT <= 0;
          end
      `Clr_Funct_Reg:
          begin
             CODE_RST <= 1;
             CODE_ENA <= 0;
             STRT_PKT_SENT <= 0;
          end
      `Send_Pkt:
          begin
             CODE_RST <= 1;
             CODE_ENA <= 0;
             STRT_PKT_SENT <= SND_STRT_PKT;
          end
      default:
          begin
             CODE_RST <= 0;
             CODE_ENA <= 0;
             STRT_PKT_SENT <= 0;
          end
   endcase
end


always @(BTC_ST or PRIO_REG or RX_STAT_MT or PRIO_AF or NORM_AF)
begin
   case (BTC_ST)
      `Get_RX_Stat_Info:
          begin
             if(PRIO_REG)
                begin
                   RX_STAT_READ <= !RX_STAT_MT && !PRIO_AF;
                end
             else
                begin
                   RX_STAT_READ <= !RX_STAT_MT && !NORM_AF;
                end
          end
      default:
          begin
             RX_STAT_READ <= 0;
          end
   endcase
end
always @(BTC_ST or PRIO_REG or NWRD_REG or PRIO_AF or NORM_AF or TC_FF_RHOLD)
begin
   case (BTC_ST)
      `Read_X_FF:
          begin
             NWRD_CNTDWN <= (NWRD_REG != 0);
             if(PRIO_REG)
                begin
                   NWRD_CNT_ENA <= (NWRD_REG != 0) && !TC_FF_RHOLD && !PRIO_AF;
                   TC_FF_READ      <= (NWRD_REG != 0) && !TC_FF_RHOLD && !PRIO_AF;
                end
             else
                begin
                   NWRD_CNT_ENA <= (NWRD_REG != 0) && !TC_FF_RHOLD && !NORM_AF;
                   TC_FF_READ      <= (NWRD_REG != 0) && !TC_FF_RHOLD && !NORM_AF;
                end
             LTNC_ST <= 1;
          end
      `TX_N_Words:
          begin
             NWRD_CNTDWN <= (NWRD_REG != 0);
             if(PRIO_REG)
                begin
                   NWRD_CNT_ENA <= (NWRD_REG != 0) && !PRIO_AF;
                end
             else
                begin
                   NWRD_CNT_ENA <= (NWRD_REG != 0) && !NORM_AF;
                end
             TC_FF_READ <= 0;
             LTNC_ST <= 1;
          end
     `R_X_FF_Off_EC:
        begin
           NWRD_CNTDWN <= 0;
           NWRD_CNT_ENA <= 0;
           TC_FF_READ <= 1;
           LTNC_ST <= 0;
        end
     default:
          begin
             NWRD_CNTDWN <= 0;
             NWRD_CNT_ENA <= 0;
             TC_FF_READ <= 0;
             LTNC_ST <= 0;
          end
   endcase
end



always @(FUNCT_REG)
begin
   case(FUNCT_REG)
      `VME_Dir_Cmds, `VME_Dir_Cnfg:
         begin
            OR_TC_BR <= `Rd_Eth_FIFO;
            EX_TC_BR <= `Direct_VME;
         end
      `Read_CRs:
         begin
            OR_TC_BR <= `Rd_Eth_FIFO;
            EX_TC_BR <= `TC_NoOp;
         end
      `Save_Cnfg_Num, `Read_Cnfg_Num_Dir, `Read_Cnfg_Num_Dcd, `Rstr_Cnfg_Num,
      `Set_Cnfg_Dflt, `Read_Cnfg_Dflt, `Set_MACs, `Read_MACs_Dir, `Read_MACs_Dcd:
         begin
            OR_TC_BR <= `Rd_Eth_FIFO;
            EX_TC_BR <= `TC_Cnfg_Store;
         end
      `Read_Drop_Mem, `Read_WSOP_Mem:
         begin
            OR_TC_BR <= `Rd_Eth_FIFO;
            EX_TC_BR <= `Rd_RX_STAT;
         end
      `Send_N_Words:
         begin
            OR_TC_BR <= `Lpback;
            EX_TC_BR <= `Spont_Rpt;
         end
      `Rdbk_Ext_Off,`Rd_Ext_Err_Cnts:
         begin
            OR_TC_BR <= `Rd_Eth_FIFO;
            EX_TC_BR <= `Rd_Ext_FIFO;
         end
      `Rd_Ext_FF, `RT_Ext_FF:
         begin
            OR_TC_BR <= `Lpback;
            EX_TC_BR <= `Rd_Ext_FIFO;
         end
      `Load_User_Reg, `Loopback:
         begin
            OR_TC_BR <= `Lpback;
            EX_TC_BR <= `TC_NoOp;
         end
//  The following functions are all set to the default option
// `VME_Cmds, `VME_Cnfg, `Flash_R_W, `Wrt_Ext_FF, `Prg_Ext_Off, `PRst_Ext_FF, `Rst_Ext_Err_Cnt, `MRst_Ext_FF,
// `ST_MK_Ext_FF, `RST_MK_Ext_FF, `Set_FF_Test, `Set_FF_VME, `ECC_enable, `ECC_disable,
// `Wrt_Eth_CR, `Wrt_Ext_CR, `Wrt_Rst_CR, `Wrt_VME_CR, `Wrt_BTO_CR, `Wrt_BGTO_CR, `Wrt_All_CRs,
// `Set_Clr_CRs,`Set_Inj_Err,`Rst_Inj_Err:
      default:
         begin
            OR_TC_BR <= `Rd_Eth_FIFO;
            EX_TC_BR <= `TC_NoOp;
         end
   endcase
end
always @(EN_SP_BR or EN_OR_BR or  EN_EX_BR or OR_TC_BR or EX_TC_BR)
begin
   case ({EN_SP_BR,EN_EX_BR,EN_OR_BR})
      3'b000:
         TC_BR <= `TC_NoOp;
      3'b001:
         TC_BR <= OR_TC_BR;
      3'b010:
         TC_BR <= EX_TC_BR;
      3'b100:
         TC_BR <= `Spont_Rpt;
      default:
         TC_BR <= `TC_NoOp;
   endcase
end

always @(BTC_ST)
begin
   case (BTC_ST)
      `OR_Req_Busses, `Wait_for_Valid_Data, `Lp_Back_Data, `Wait_for_EOD, `Wait_for_Done:
          begin
             EN_SP_BR <= 0;
             EN_EX_BR <= 0;
             EN_OR_BR <= 1;
          end
      `EX_Req_Busses, `Get_RX_Stat_Info, `TX_N_Words, `R_X_FF_Off_EC, `Read_X_FF, `Cnfg2Flash:
          begin
             EN_SP_BR <= 0;
             EN_EX_BR <= 1;
             EN_OR_BR <= 0;
          end
      `Spnt_Req_Busses, `TX_Spnt_Pkt:
          begin
             EN_SP_BR <= 1;
             EN_EX_BR <= 0;
             EN_OR_BR <= 0;
          end
      default:
          begin
             EN_SP_BR <= 0;
             EN_EX_BR <= 0;
             EN_OR_BR <= 0;
          end
   endcase
end

always @(BTC_ST or PRIO_REG or VD1 or VD2 or RSR3 or NWCE1 or FUNCT_REG or FF_WHOLD or FL_INFF_AF)
begin
   case (BTC_ST)
      `Wait_for_Valid_Data:
          begin
             FRAME_REQ <= (!FF_WHOLD && ((FUNCT_REG == `Wrt_Ext_FF) || (FUNCT_REG == `VME_Cmds)) ||
                          (!FL_INFF_AF && (FUNCT_REG == `Flash_R_W)) ||
                          !((FUNCT_REG == `Wrt_Ext_FF) || (FUNCT_REG == `VME_Cmds) || (FUNCT_REG == `Flash_R_W)));
             TC_SPONT_DAT <= 0;
             TC_PRIO_DAT  <= 0;
             TC_NORM_DAT  <= 0;
          end
      `Lp_Back_Data:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 0;
             if(PRIO_REG)
                begin
                   TC_PRIO_DAT <= VD1;
                   TC_NORM_DAT <= 0;
                end
             else
                begin
                   TC_PRIO_DAT <= 0;
                   TC_NORM_DAT <= VD1;
                end
          end
      `Wait_for_EOD:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 0;
             TC_PRIO_DAT <= 0;
             TC_NORM_DAT <= 0;
          end
      `Get_RX_Stat_Info:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 0;
             if(PRIO_REG)
                begin
                   TC_PRIO_DAT <= RSR3;
                   TC_NORM_DAT <= 0;
                end
             else
                begin
                   TC_PRIO_DAT <= 0;
                   TC_NORM_DAT <= RSR3;
                end
          end
      `TX_N_Words:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 0;
             if(PRIO_REG)
                begin
                   TC_PRIO_DAT <= NWCE1;
                   TC_NORM_DAT <= 0;
                end
             else
                begin
                   TC_PRIO_DAT <= 0;
                   TC_NORM_DAT <= NWCE1;
                end
          end
      `R_X_FF_Off_EC, `Read_X_FF:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 0;
             if(PRIO_REG)
                begin
                   TC_PRIO_DAT <= VD2;
                   TC_NORM_DAT <= 0;
                end
             else
                begin
                   TC_PRIO_DAT <= 0;
                   TC_NORM_DAT <= VD2;
                end
          end
      `TX_Spnt_Pkt:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 1;
             TC_PRIO_DAT <= 0;
             TC_NORM_DAT <= 0;
          end
      default:
          begin
             FRAME_REQ <= 0;
             TC_SPONT_DAT <= 0;
             TC_PRIO_DAT  <= 0;
             TC_NORM_DAT  <= 0;
          end
   endcase
end
always @(BTC_ST or STATCNT or SP_TXTYPE)
begin
   case (BTC_ST)
      `Lp_Back_Data:
         TC_TXTYPE <= 8'h01;
      `Get_RX_Stat_Info:
         TC_TXTYPE <= {4'h0,STATCNT};
      `TX_N_Words:
         TC_TXTYPE <= 8'h02;
      `R_X_FF_Off_EC, `Read_X_FF:
         TC_TXTYPE <= 8'h03;
      `TX_Spnt_Pkt:
         TC_TXTYPE <= SP_TXTYPE;
      default:
         TC_TXTYPE <= 8'h00;
   endcase
end
always @(BTC_ST or STATCNT or PRIO_REG or SP_TXTYPE)
begin
   case (BTC_ST)
      `Send_PP:
         begin
            TC_SND_SPONT_NOW <= 0;
            if(PRIO_REG)
               begin
                  TC_SND_PRIO_NOW <= 1;
                  TC_SND_NORM_NOW <= 0;
               end
            else
               begin
                  TC_SND_PRIO_NOW <= 0;
                  TC_SND_NORM_NOW <= 1;
               end
         end
      `Send_Pkt:
         begin
            if(SPONT_REG)
               begin
                  TC_SND_SPONT_NOW <= 1;
                  TC_SND_PRIO_NOW <= 0;
                  TC_SND_NORM_NOW <= 0;
               end
            else if(PRIO_REG)
               begin
                  TC_SND_SPONT_NOW <= 0;
                  TC_SND_PRIO_NOW <= 1;
                  TC_SND_NORM_NOW <= 0;
               end
            else
               begin
                  TC_SND_SPONT_NOW <= 0;
                  TC_SND_PRIO_NOW <= 0;
                  TC_SND_NORM_NOW <= 1;
               end
         end
      default:
         begin
            TC_SND_PRIO_NOW <= 0;
            TC_SND_NORM_NOW <= 0;
            TC_SND_SPONT_NOW <= 0;
         end
   endcase
end

always @(TB_BG_VMER or
        V_TXTYPE or V_NORM_DAT or V_SEND_NORM or V_PRIO_DAT or V_SEND_PRIO or V_SPONT_DAT or V_SEND_SPONT or
        TC_TXTYPE or TC_NORM_DAT or TC_SND_NORM_NOW or TC_PRIO_DAT or TC_SND_PRIO_NOW or  TC_SPONT_DAT or TC_SND_SPONT_NOW or
        FL_ODV or FL_SND_PKT or FL_TXTYPE or TB_BG_FL or
        CNFG_TX_VALDAT or CNFG_SND_PKT or CNFG_TXTYPE or TB_BG_CNFG)  
begin
   if(TB_BG_VMER)
      begin
         TXTYPE <= V_TXTYPE;
         NORM_DAT <= V_NORM_DAT;
         PRIO_DAT <= V_PRIO_DAT;
         SPONT_DAT <= V_SPONT_DAT;
         SND_NORM_NOW <= V_SEND_NORM;
         SND_PRIO_NOW <= V_SEND_PRIO;
         SND_SPONT_NOW <= V_SEND_SPONT;
      end
   else if(TB_BG_FL)
      begin
         TXTYPE <= FL_TXTYPE;
         NORM_DAT <= FL_ODV;
         PRIO_DAT <= 0;
         SPONT_DAT <= 0;
         SND_NORM_NOW <= FL_SND_PKT;
         SND_PRIO_NOW <= 0;
         SND_SPONT_NOW <= 0;
      end
   else if(TB_BG_CNFG)
      begin
         TXTYPE <= CNFG_TXTYPE;
         NORM_DAT <= CNFG_TX_VALDAT;
         PRIO_DAT <= 0;
         SPONT_DAT <= 0;
         SND_NORM_NOW <= CNFG_SND_PKT;
         SND_PRIO_NOW <= 0;
         SND_SPONT_NOW <= 0;
      end
   else
      begin
         TXTYPE <= TC_TXTYPE;
         NORM_DAT <= TC_NORM_DAT;
         PRIO_DAT <= TC_PRIO_DAT;
         SPONT_DAT <= TC_SPONT_DAT;
         SND_NORM_NOW <= TC_SND_NORM_NOW;
         SND_PRIO_NOW <= TC_SND_PRIO_NOW;
         SND_SPONT_NOW <= TC_SND_SPONT_NOW;
      end
end

always @(FF_TEST_MODE or V_FF_READ or V_RFUNCT or FF_ODV or FF_RHOLD or TC_RFUNCT or TC_FF_READ)  
begin
   if(FF_TEST_MODE)
      begin
         RFUNCT <= TC_RFUNCT;
         FF_READ <= TC_FF_READ;
         V_FF_ODV <= 0;
         V_FF_RHOLD <= 1;
         TC_FF_ODV <= FF_ODV;
         TC_FF_RHOLD <= FF_RHOLD;
      end
   else
      begin
         RFUNCT <= V_RFUNCT;
         FF_READ <= V_FF_READ;
         V_FF_ODV <= FF_ODV;
         V_FF_RHOLD <= FF_RHOLD;
         TC_FF_ODV <= 0;
         TC_FF_RHOLD <= 1;
      end
end

always @(BTC_ST)
begin
   case (BTC_ST)
      `Send_Pkt:
         RST_PP <= 1;
      default:
         RST_PP <= 0;
   endcase
end
always @(BTC_ST)
begin
   case (BTC_ST)
      `Load_Errs:
         begin
            LD_SP_ERRS <= 1;
            LD_SP_WARNS <= 0;
            LD_SP_INFOS <= 0;
            SET_SPONT <= 1;
         end
      `Load_Warns:
         begin
            LD_SP_ERRS <= 0;
            LD_SP_WARNS <= 1;
            LD_SP_INFOS <= 0;
            SET_SPONT <= 1;
         end
      `Load_Infos:
         begin
            LD_SP_ERRS <= 0;
            LD_SP_WARNS <= 0;
            LD_SP_INFOS <= 1;
            SET_SPONT <= 1;
         end
      default:
         begin
            LD_SP_ERRS <= 0;
            LD_SP_WARNS <= 0;
            LD_SP_INFOS <= 0;
            SET_SPONT <= 0;
         end
   endcase
end

always @(posedge CLK or posedge BTC_RST)
begin
   if(BTC_RST)
      SP_TXTYPE <= 8'h00;
   else
      if(LD_SP_ERRS)
         SP_TXTYPE <= 8'h0F;
      else if(LD_SP_WARNS)
         SP_TXTYPE <= 8'h0E;
      else if(LD_SP_INFOS)
         SP_TXTYPE <= 8'h0D;
      else
         SP_TXTYPE <= SP_TXTYPE;
end

always @(posedge CLK)
begin
   LTNC1 <= LTNC_ST;
   LTNC2 <= LTNC1;
   LTNC3 <= LTNC2;
   LTNC4 <= LTNC3;
   LTNC5 <= LTNC4;
   LTNC6 <= LTNC5;
   LTNC7 <= LTNC6;
   LTNC8 <= LTNC7;
   LTNC9 <= LTNC8;
   LTNC10 <= LTNC9;
   LTNC11 <= LTNC10;
end


always @(FF_TEST_MODE)
begin
   if(FF_TEST_MODE)
      VIN_CTRL_CODE <= `VME_idle;
   else
      VIN_CTRL_CODE <= `VME_CMD_FF;
end

endmodule
