// Verilog model  - Wed Oct 27 09:30:09 2004

`timescale 1ns / 1ps

module vme_ctrlr(CLK, DATA_IN, FF_ODV, FF_RHOLD, FF_HAS_DATA, IN_CTRL_CODE,
      MSTR_BUSY, MSTR_DAV, MSTR_DATA_SZ, MSTR_ERR, NEXT_WRD, RSLT_DATA, RST,
      RB_BG_VMEW, FB_BG_VMEW, TB_BG_VMEW, TB_BG_VMER, VMER_OE,
      ACKN_MSTR, DATA_OUT,
      EXECUTE, FF_READ, FULL_ADDR, FULL_DATA, LAST_WORD, NEXT_RDY, VMEW_BR, VMER_BR, RFUNCT,
      TXTYPE, NORM_DAT, PRIO_DAT, SPONT_DAT, SEND_NORM, SEND_PRIO, SEND_SPONT,
      DATA_SZ, TRNS_TYP, DLY_TYP, WRT_RDB);

    input CLK;
    input [15:0] DATA_IN;
    input FF_ODV;
    input FF_RHOLD;
    input FF_HAS_DATA;
    input [2:0] IN_CTRL_CODE;
    input MSTR_BUSY;
    input MSTR_DAV;
    input [1:0] MSTR_DATA_SZ;
    input [7:0] MSTR_ERR;
    input NEXT_WRD;
    input [63:0] RSLT_DATA;
    input RST;
    input RB_BG_VMEW;
    input FB_BG_VMEW;
    input TB_BG_VMEW;
    input TB_BG_VMER;
    input VMER_OE;
   output ACKN_MSTR;
   output [15:0] DATA_OUT;
   output EXECUTE;
   output FF_READ;
   output [63:0] FULL_ADDR;
   output [63:0] FULL_DATA;
   output LAST_WORD;
   output NEXT_RDY;
   output [1:0] VMEW_BR;
   output VMER_BR;
   output [2:0] RFUNCT;
   output [7:0] TXTYPE;
   output NORM_DAT;
   output PRIO_DAT;
   output SPONT_DAT;
   output SEND_NORM;
   output SEND_PRIO;
   output SEND_SPONT;
   output [1:0] DATA_SZ;
   output [1:0] TRNS_TYP;
   output [2:0] DLY_TYP;
   output WRT_RDB;
//   output [7:0] TEST_OUT;


//reg [7:0] TEST_OUT;
reg [5:0] VWRT_ST;
reg [3:0] VFFW_ST;
reg [2:0] VFFR_ST;
reg [2:0] RFUNCT;
reg LOAD_TYPE;
reg WRT_RDB;
reg [1:0] DATA_SZ;
reg [2:0] ADDR_SZ;
reg [1:0] TRNS_TYP;
reg [2:0] DLY_TYP;
reg [63:0] FULL_ADDR;
reg [63:0] FULL_DATA;
reg FF_READ;
reg LOAD_UNITS;
reg DEC_UNITS;
reg [15:0] UNITS;
reg LOAD_DCNT;
reg DEC_DCNT;
reg [15:0] DCNT;
reg PUSH;
reg POP;
reg V_POP;
reg VFF_CE;
reg VFF_DIR;
reg [63:0] DATA_REG;
reg LOAD_DATA_REG;
reg ACKN_MSTR;
reg [1:0] DATA_SIZE;
reg ANY_READ;
reg RD_CMPLT;
reg PKT_DONE;
reg SEND;
reg WAIT_SEND;
reg SET_EOP;
reg SET_VLDT;
reg EOP;
reg EOP_WR;
reg VLDT;
wire EOP_RD;
wire VLDT_RD;
reg VRD_IDLE;
reg [15:0] DATA_OUT;
reg [15:0] VFF_IN;
reg [7:0] TXTYPE;
reg NORM_DAT;
wire PRIO_DAT;
wire SPONT_DAT;
reg SEND_NORM;
wire SEND_PRIO;
wire SEND_SPONT;
reg VD1;
reg [1:0] VMEW_BR;
reg VMER_BR;
reg BG_VMEW;
reg EXECUTE;   
reg BIP;
reg SET_BIP;
reg RST_BIP;
reg NEXT_RDY;
reg [2:0]FTCH_WRDS;
reg FF_ODV_D1;
reg FF_ODV_D2;
reg FF_ODV_D3;
reg FF_ODV_D4;
reg ADDR_PHASE;
reg DATA_PHASE;

wire FFODV1;
wire FFODV2;
wire FFODV3;
wire FFODV4;
wire DAT_CAP;
wire LAST_UNIT;
wire LAST_WORD;
wire [15:0] VFF_OUT; 
//wire [9:0] VME_WADDR; 
//wire [9:0] VME_RADDR; 
//wire [9:0] VFF_CNT;
wire [3:0] VME_WADDR; 
wire [3:0] VME_RADDR; 
wire [3:0] VFF_CNT;
wire VFF_MT;

   
`ifdef HEADER
`else
`include "header.v"
`endif


assign PRIO_DAT = 0;
assign SPONT_DAT = 0;
assign SEND_PRIO = 0;
assign SEND_SPONT = 0;
//assign   VFF_MT = (VFF_CNT == `Zero_2);
assign   VFF_MT = (VFF_CNT == 4'h0);
assign LAST_UNIT = (UNITS == 16'h0001);
assign LAST_WORD = (DCNT == 16'h0001);
assign DAT_CAP = !FF_ODV & FF_ODV_D1;
assign FFODV1 = FF_ODV & !FF_ODV_D1;
assign FFODV2 = FF_ODV & FF_ODV_D1 & !FF_ODV_D2;
assign FFODV3 = FF_ODV & FF_ODV_D2 & !FF_ODV_D3;
assign FFODV4 = FF_ODV & FF_ODV_D3 & !FF_ODV_D4;
assign DAT_CAP = !FF_ODV & FF_ODV_D1;

/*
always @(posedge CLK)
begin
   TEST_OUT[7] <= SEND;
   TEST_OUT[6] <= MSTR_DAV;
   TEST_OUT[5] <= EOP_WR;
   TEST_OUT[4] <= VLDT;
   TEST_OUT[3:0] <= VFFW_ST;
end
*/
always @(posedge CLK)
begin
   FF_ODV_D1 <= FF_ODV;
   FF_ODV_D2 <= FF_ODV_D1;
   FF_ODV_D3 <= FF_ODV_D2;
   FF_ODV_D4 <= FF_ODV_D3;
end

always @(posedge CLK)
begin
   if(LOAD_DATA_REG)
      begin
         DATA_REG <= RSLT_DATA;
         DATA_SIZE <= MSTR_DATA_SZ;
      end
   else
      begin
         DATA_REG <= DATA_REG;
         DATA_SIZE <= DATA_SIZE;
      end
end


always @(posedge CLK)
begin
   if(LOAD_TYPE)
      begin
         DLY_TYP <= DATA_IN[10:8];
         ADDR_SZ <= DATA_IN[7:5];
         WRT_RDB <= DATA_IN[4];
         DATA_SZ <= DATA_IN[3:2];
         TRNS_TYP <= DATA_IN[1:0];
         if(DATA_IN[10:8] == 3'd0) // Delay type is zero
            case(DATA_IN[7:5])     // Address Size
               `ASZ_A16:           //A16        (1 word to read)
                  FTCH_WRDS <= 3'd1;
               `ASZ_A24,`ASZ_A32:  //A24,A32 (2 words to read)
                  FTCH_WRDS <= 3'd2;
               `ASZ_A40:           //A40        (3 words to read)
                  FTCH_WRDS <= 3'd3;
               `ASZ_A64:           //A64        (4 words to read)
                  FTCH_WRDS <= 3'd4;
               default:            // no addr to read
                  FTCH_WRDS <= 3'd0;
            endcase
         else  // Delay type is not zero
            case(DATA_IN[10:8])            // Delay Type
               `D4nsX16,`D16nsX16,`D16usX16: // (1 delay word to read)
                  FTCH_WRDS <= 3'd1;
               `D4nsX32,`D16nsX32,`D16usX32: // (2 words to read)
                  FTCH_WRDS <= 3'd2;
               default:                         // (nothing to read)
                  FTCH_WRDS <= 3'd0;
            endcase
      end
   else
      begin
         DLY_TYP <= DLY_TYP;
         ADDR_SZ <= ADDR_SZ;
         WRT_RDB <= WRT_RDB;
         DATA_SZ <= DATA_SZ;
         TRNS_TYP <= TRNS_TYP;
         FTCH_WRDS <= FTCH_WRDS;
      end
end

always @(posedge CLK)
begin
   if(ADDR_PHASE)
      if(DLY_TYP == `No_Dly)
         case(ADDR_SZ)
            `ASZ_A16: //A16
               if(FFODV1)
                  FULL_ADDR <= {48'h000000000000,DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A24:        //A24
               if(FFODV1)
                  FULL_ADDR <= {40'h0000000000,DATA_IN[7:0],FULL_ADDR[15:0]};
               else if(FFODV2)
                  FULL_ADDR <= {40'h0000000000,FULL_ADDR[23:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A32: //A32
               if(FFODV1)
                  FULL_ADDR <= {32'h00000000,DATA_IN,FULL_ADDR[15:0]};
               else if(FFODV2)
                  FULL_ADDR <= {32'h00000000,FULL_ADDR[31:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A40:        //A40
               if(FFODV1)
                  FULL_ADDR <= {24'h000000,DATA_IN[7:0],FULL_ADDR[31:0]};
               else if(FFODV2)
                  FULL_ADDR <= {24'h000000,FULL_ADDR[39:32],DATA_IN[15:0],FULL_ADDR[15:0]};
               else if(FFODV3)
                  FULL_ADDR <= {24'h000000,FULL_ADDR[39:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A64:        //A64
               if(FFODV1)
                  FULL_ADDR <= {DATA_IN,FULL_ADDR[47:0]};
               else if(FFODV2)
                  FULL_ADDR <= {FULL_ADDR[63:48],DATA_IN,FULL_ADDR[31:0]};
               else if(FFODV3)
                  FULL_ADDR <= {FULL_ADDR[63:32],DATA_IN,FULL_ADDR[15:0]};
               else if(FFODV4)
                  FULL_ADDR <= {FULL_ADDR[63:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            default:                  // no addr to read
               FULL_ADDR <= FULL_ADDR;
         endcase
      else
         case(DLY_TYP)
            `D4nsX16,`D16nsX16,`D16usX16: //16 Bit range
               if(FFODV1)
                  FULL_ADDR <= {48'h000000000000,DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `D4nsX32,`D16nsX32,`D16usX32:        //32 Bit range
               if(FFODV1)
                  FULL_ADDR <= {32'h00000000,DATA_IN,FULL_ADDR[15:0]};
               else if(FFODV2)
                  FULL_ADDR <= {32'h00000000,FULL_ADDR[31:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            default:                  // no addr to read
               FULL_ADDR <= FULL_ADDR;
         endcase
   else
      FULL_ADDR <= FULL_ADDR;
end
always @(posedge CLK)
begin
   if(DATA_PHASE)
      case(DATA_SZ)
         `Byte:
            if(FFODV1)
               FULL_DATA <= {56'h00000000000000,DATA_IN[7:0]};
            else
               FULL_DATA <= FULL_DATA;
         `Word:
            if(FFODV1)
               FULL_DATA <= {48'h000000000000,DATA_IN};
            else
               FULL_DATA <= FULL_DATA;
         `LWord:
            if(FFODV1)
               FULL_DATA <= {32'h00000000,DATA_IN,FULL_DATA[15:0]};
            else if(FFODV2)
               FULL_DATA <= {32'h00000000,FULL_DATA[31:16],DATA_IN};
            else
               FULL_DATA <= FULL_DATA;
         `Eight:
            if(FFODV1)
               FULL_DATA <= {DATA_IN,FULL_DATA[47:0]};
            else if(FFODV2)
               FULL_DATA <= {FULL_DATA[63:48],DATA_IN,FULL_DATA[31:0]};
            else if(FFODV3)
               FULL_DATA <= {FULL_DATA[63:32],DATA_IN,FULL_DATA[15:0]};
            else if(FFODV4)
               FULL_DATA <= {FULL_DATA[63:16],DATA_IN};
            else
               FULL_DATA <= FULL_DATA;
         default:
               FULL_DATA <= FULL_DATA;
      endcase
   else
      FULL_DATA <= FULL_DATA;
end
    
always @(posedge CLK or posedge RST)
begin: VME_WRT_CTRL_FSM
   if(RST)
      VWRT_ST <= `VW_idle;
   else
      case(VWRT_ST)
         `VW_idle:
            begin
               if((IN_CTRL_CODE == `VME_CMD_FF) && FF_HAS_DATA)
                  VWRT_ST <= `VW_Req_Bus;
               else 
                  VWRT_ST <= `VW_idle;
            end
         `VW_Req_Bus:
            begin
               if(BG_VMEW)
                  VWRT_ST <= `Rd_FIFO;
               else 
                  VWRT_ST <= `VW_Req_Bus;
            end
         `Rd_FIFO:
            begin
               if(!FF_RHOLD)
                  VWRT_ST <= `Rd_units;
               else 
                  VWRT_ST <= `Rd_FIFO;
            end
         `Rd_units:
            VWRT_ST <= `Ld_units;
         `Ld_units:
            begin
               if(FF_ODV)
                  VWRT_ST <= `Rd_type;
               else 
                  VWRT_ST <= `Ld_units;
            end
         `Rd_type:
            VWRT_ST <= `Ld_type;
         `Ld_type:
            begin
               if(DAT_CAP)
                  case(FTCH_WRDS)
                     3'd1:          //(1 word to read)
                        VWRT_ST <= `Rd_Wrd_1a;
                     3'd2:          //(2 words to read)
                        VWRT_ST <= `Rd_Wrd_1b;
                     3'd3:          //(3 words to read)
                        VWRT_ST <= `Rd_Wrd_1c;
                     3'd4:          //(4 words to read)
                        VWRT_ST <= `Rd_Wrd_1d;
                     default:       // no addr to read
                        VWRT_ST <= `Dec_Units;
                  endcase
               else 
                  VWRT_ST <= `Ld_type;
            end
         `Rd_Wrd_1a:
            VWRT_ST <= `Ld_Add_Pause;
         `Rd_Wrd_1b:
            VWRT_ST <= `Rd_Wrd_2b;
         `Rd_Wrd_2b:
            VWRT_ST <= `Ld_Add_Pause;
         `Rd_Wrd_1c:
            VWRT_ST <= `Rd_Wrd_2c;
         `Rd_Wrd_2c:
            VWRT_ST <= `Rd_Wrd_3c;
         `Rd_Wrd_3c:
            VWRT_ST <= `Ld_Add_Pause;
         `Rd_Wrd_1d:
            VWRT_ST <= `Rd_Wrd_2d;
         `Rd_Wrd_2d:
            VWRT_ST <= `Rd_Wrd_3d;
         `Rd_Wrd_3d:
            VWRT_ST <= `Rd_Wrd_4d;
         `Rd_Wrd_4d:
            VWRT_ST <= `Ld_Add_Pause;
         `Ld_Add_Pause:
            begin
               if(DAT_CAP)
                  if((TRNS_TYP == `BLOCK) && (DLY_TYP == `No_Dly))
                     VWRT_ST <= `Rd_Dcnt;
                  else
                     VWRT_ST <= `Continue;
               else 
                  VWRT_ST <= `Ld_Add_Pause;
            end
         `Rd_Dcnt:
            VWRT_ST <= `Ld_Dcnt;
         `Ld_Dcnt:
            begin
               if(FF_ODV)
                  VWRT_ST <= `Continue;
               else 
                  VWRT_ST <= `Ld_Dcnt;
            end
         `Continue:
            begin
               if(WRT_RDB && (DLY_TYP == `No_Dly))
                  case(DATA_SZ)
                     `LWord:          //D32 Quad byte (2 words to read)
                        VWRT_ST <= `Rd_Dat_1b;
                     `Eight:          //D64        Eight bytes (4 words to read)
                        VWRT_ST <= `Rd_Dat_1d;
                     default:         // D08, & D16; Byte, & Word (1 word to read)
                        VWRT_ST <= `Rd_Dat_1a;
                  endcase
               else 
                  VWRT_ST <= `VPause;
            end
         `Rd_Dat_1a:
            VWRT_ST <= `Ld_Dat_Pause;
         `Rd_Dat_1b:
            VWRT_ST <= `Rd_Dat_2b;
         `Rd_Dat_2b:
            VWRT_ST <= `Ld_Dat_Pause;
         `Rd_Dat_1d:
            VWRT_ST <= `Rd_Dat_2d;
         `Rd_Dat_2d:
            VWRT_ST <= `Rd_Dat_3d;
         `Rd_Dat_3d:
            VWRT_ST <= `Rd_Dat_4d;
         `Rd_Dat_4d:
            VWRT_ST <= `Ld_Dat_Pause;
         `Ld_Dat_Pause:
            begin
               if(DAT_CAP)
                  VWRT_ST <= `VPause;
               else 
                  VWRT_ST <= `Ld_Dat_Pause;
            end
         `VPause:
            begin
               if((TRNS_TYP == `BLOCK) && (DLY_TYP == `No_Dly) && ((!MSTR_BUSY && !BIP) || (BIP && NEXT_WRD)))
                  VWRT_ST <= `Execute_Blk;
               else if(!MSTR_BUSY && (TRNS_TYP != `BLOCK))
                  VWRT_ST <= `Execute;
               else 
                  VWRT_ST <= `VPause;
            end
         `Execute_Blk:
            begin
               if(MSTR_BUSY && !NEXT_WRD && !LAST_WORD)
                  VWRT_ST <= `Dec_Dcnt;
               else if(MSTR_BUSY && !NEXT_WRD && LAST_WORD)
                  VWRT_ST <= `Dec_Units;
               else 
                  VWRT_ST <= `Execute_Blk;
            end
         `Dec_Dcnt:
            VWRT_ST <= `Continue;
         `Execute:
            begin
               if(MSTR_BUSY)
                  VWRT_ST <= `Dec_Units;
               else 
                  VWRT_ST <= `Execute;
            end
         `Dec_Units:
            begin
               if(LAST_UNIT)
                  VWRT_ST <= `Wait4VRd_Idle;
               else 
                  VWRT_ST <= `Rd_type;
            end
         `Wait4VRd_Idle:
            begin
               if(VRD_IDLE)
                  VWRT_ST <= `Wait4Cmplt;
               else 
                  VWRT_ST <= `Wait4VRd_Idle;
            end
         `Wait4Cmplt:
            begin
               if(!ANY_READ)
                  VWRT_ST <= `VW_idle;
               else if(ANY_READ && RD_CMPLT)
                  VWRT_ST <= `VW_idle;
               else 
                  VWRT_ST <= `Wait4Cmplt;
            end
         default:
            VWRT_ST <= `VW_idle;
      endcase
end

always @(VWRT_ST)
begin
   case (VWRT_ST)
      `VW_idle:
         begin
            RFUNCT <= `RNoOp;
            VMEW_BR <= `VMEW_NoOp;
         end
      `VW_Req_Bus:
         begin
            RFUNCT <= `RNoOp;
            VMEW_BR <= `VME_fr_FIFO;
         end
      default:
         begin
            RFUNCT <= `Rd_FF;
            VMEW_BR <= `VME_fr_FIFO;
         end
   endcase
end

always @(VMEW_BR or RB_BG_VMEW or FB_BG_VMEW or TB_BG_VMEW)
begin
   case(VMEW_BR)
      `VMEW_NoOp:
         BG_VMEW <= 0;
      `VME_fr_FIFO:
         BG_VMEW <= FB_BG_VMEW;
      `VME_cnfg_save:
         BG_VMEW <= RB_BG_VMEW && FB_BG_VMEW && TB_BG_VMEW;
      default:
         BG_VMEW <= 0;
   endcase
end

always @(VWRT_ST)
begin
   case (VWRT_ST)
      `Rd_units,`Rd_type,`Rd_Dcnt:
         begin
            FF_READ <= 1;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 0;
         end
      `Rd_Wrd_1a,`Rd_Wrd_1b,`Rd_Wrd_2b,`Rd_Wrd_1c,`Rd_Wrd_2c,`Rd_Wrd_3c,`Rd_Wrd_1d,`Rd_Wrd_2d,`Rd_Wrd_3d,`Rd_Wrd_4d:
         begin
            FF_READ <= 1;
            ADDR_PHASE <= 1;
            DATA_PHASE <= 0;
         end
      `Ld_Add_Pause:
         begin
            FF_READ <= 0;
            ADDR_PHASE <= 1;
            DATA_PHASE <= 0;
         end
      `Rd_Dat_1a,`Rd_Dat_1b,`Rd_Dat_2b,`Rd_Dat_1d,`Rd_Dat_2d,`Rd_Dat_3d,`Rd_Dat_4d:
         begin
            FF_READ <= 1;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 1;
         end
      `Ld_Dat_Pause:
         begin
            FF_READ <= 0;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 1;
         end
      default:  
         begin
            FF_READ <= 0;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 0;
         end
   endcase
end

always @(VWRT_ST or FF_ODV)
begin
   case (VWRT_ST)
      `Ld_units:
         begin
            LOAD_UNITS <= FF_ODV;
            LOAD_TYPE <= 0;
            LOAD_DCNT <= 0;
         end
      `Ld_type:
         begin
            LOAD_UNITS <= 0;
            LOAD_TYPE <= FF_ODV;
            LOAD_DCNT <= 0;
         end
      `Ld_Dcnt:
         begin
            LOAD_UNITS <= 0;
            LOAD_TYPE <= 0;
            LOAD_DCNT <= FF_ODV;
         end
      default:
         begin
            LOAD_UNITS <= 0;
            LOAD_TYPE <= 0;
            LOAD_DCNT <= 0;
         end
   endcase
end

always @(VWRT_ST or ANY_READ or WRT_RDB or RD_CMPLT)
begin
   case (VWRT_ST)
      `Wait4Cmplt:
         begin
            SEND <= ANY_READ && WRT_RDB;
            WAIT_SEND <= ANY_READ && !WRT_RDB;
            PKT_DONE <= RD_CMPLT;
         end
      default:
         begin
            SEND <= 0;
            WAIT_SEND <= 0;
            PKT_DONE <= 0;
         end
   endcase
end

always @(VWRT_ST )
begin
   case (VWRT_ST)
      `Execute:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 0;
            EXECUTE <= 1;
            SET_BIP <= 0;
            RST_BIP <= 0;
            NEXT_RDY <= 0;
         end
      `Execute_Blk:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 0;
            EXECUTE <= 1;
            SET_BIP <= 1;
            RST_BIP <= 0;
            NEXT_RDY <= 1;
         end
      `Dec_Units:
         begin
            DEC_UNITS <= 1;
            DEC_DCNT <= 0;
            EXECUTE <= 0;
            SET_BIP <= 0;
            RST_BIP <= 1;
            NEXT_RDY <= 0;
         end
      `Dec_Dcnt:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 1;
            EXECUTE <= 0;
            SET_BIP <= 0;
            RST_BIP <= 0;
            NEXT_RDY <= 0;
         end
      default:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 0;
            EXECUTE <= 0;
            SET_BIP <= 0;
            RST_BIP <= 0;
            NEXT_RDY <= 0;
         end
   endcase
end

always @(posedge CLK)
begin
   if(RST)
      UNITS <= 0;
   else
      if (LOAD_UNITS)
         UNITS <= DATA_IN;
      else if (DEC_UNITS)
         UNITS <= UNITS -1;
      else
         UNITS <= UNITS;
end
always @(posedge CLK)
begin
   if(RST)
      DCNT <= 16'h0001;
   else
      if (LOAD_DCNT)
         DCNT <= DATA_IN;
      else if (DEC_DCNT)
         DCNT <= DCNT -1;
      else
         DCNT <= DCNT;
end
always @(posedge CLK)
begin
   if (RST || PKT_DONE)
      ANY_READ <= 0;
   else        if((VWRT_ST == `Ld_Add_Pause) && !WRT_RDB && (DLY_TYP == `No_Dly))
      ANY_READ <= 1;
   else
      ANY_READ <= ANY_READ;
end
always @(posedge CLK)
begin
   if (RST || RST_BIP)
      BIP <= 0;
   else        if(SET_BIP)
      BIP <= 1;
   else
      BIP <= BIP;
end

///////////////////////////////////////////////////////////////
//                                                           //
// VME Read control                                          //
//                                                           //
///////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////
//                                                           //
// Read FIFO write control                                   //
//                                                           //
///////////////////////////////////////////////////////////////

always @(posedge CLK or posedge RST)
begin: VME_RD_FFWRT_CTRL_FSM
   if(RST)
      VFFW_ST <= `VRd_Idle;
   else
      case(VFFW_ST)
         `VRd_Idle:
            begin
               if(MSTR_DAV)
                  VFFW_ST <= `Ld_Drbk;
               else if(SEND)
                  VFFW_ST <= `Push8;
               else 
                  VFFW_ST <= `VRd_Idle;
            end
         `Ld_Drbk:
            VFFW_ST <= `Ackn;
         `Ackn:
            begin
               case (DATA_SIZE)
                 `Byte:
                     VFFW_ST <= `Push8;
                 `Word:
                     VFFW_ST <= `Push16;
                 `LWord:
                     VFFW_ST <= `Push32A;
                 `Eight:
                     VFFW_ST <= `Push64A;
                 default:
                     VFFW_ST <= `Push16;
               endcase
            end
         `Push8:
            VFFW_ST <= `Rd_Cmplt;
         `Push16:
            VFFW_ST <= `Rd_Cmplt;
         `Push32A:
            VFFW_ST <= `Push32B;
         `Push32B:
            VFFW_ST <= `Rd_Cmplt;
         `Push64A:
            VFFW_ST <= `Push64B;
         `Push64B:
            VFFW_ST <= `Push64C;
         `Push64C:
            VFFW_ST <= `Push64D;
         `Push64D:
            VFFW_ST <= `Rd_Cmplt;
         `Rd_Cmplt:
            VFFW_ST <= `VRd_Idle;
         default:
            VFFW_ST <= `VRd_Idle;
      endcase
end

always @(VFFW_ST or SEND or WAIT_SEND or MSTR_DAV)
begin
   case (VFFW_ST)
      `VRd_Idle:
         begin
            SET_EOP <= SEND || WAIT_SEND;
            SET_VLDT <= MSTR_DAV;
            RD_CMPLT <= 0;
            VRD_IDLE <= 1;
         end
      `Rd_Cmplt:
         begin
            SET_EOP <= 0;
            SET_VLDT <= 0;
            RD_CMPLT <= 1;
            VRD_IDLE <= 0;
         end
      default:
         begin
            SET_EOP <= 0;
            SET_VLDT <= 0;
            RD_CMPLT <= 0;
            VRD_IDLE <= 0;
         end
   endcase
end
always @(posedge CLK)
begin
   if (RST || RD_CMPLT)
      EOP<= 0;
   else if(SET_EOP)
      EOP <= 1;
   else
      EOP <= EOP;
   if (RST || RD_CMPLT)
      VLDT <= 0;
   else if(SET_VLDT)
      VLDT <= 1;
   else
      VLDT <= VLDT;
end

always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Push8,`Push16,`Push32A,`Push32B,`Push64A,`Push64B,`Push64C,`Push64D:
         PUSH <= 1;
      default:
         PUSH <= 0;
   endcase
end
always @(VFFW_ST or EOP)
begin
   case (VFFW_ST)
      `Push8,`Push16,`Push32B,`Push64D:
         EOP_WR <= EOP;
      default:
         EOP_WR <= 0;
   endcase
end
always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Ld_Drbk:
         LOAD_DATA_REG <= 1;
      default:
         LOAD_DATA_REG <= 0;
   endcase
end
always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Ackn:
         ACKN_MSTR <= 1;
      default:
         ACKN_MSTR <= 0;
   endcase
end
always @(VFFW_ST or DATA_REG)
begin
   case (VFFW_ST)
      `Push8:
         VFF_IN <= {8'h00,DATA_REG[7:0]};
      `Push16:
         VFF_IN <= DATA_REG[15:0];
      `Push32A:
         VFF_IN <= DATA_REG[31:16];
      `Push32B:
         VFF_IN <= DATA_REG[15:0];
      `Push64A:
         VFF_IN <= DATA_REG[63:48];
      `Push64B:
         VFF_IN <= DATA_REG[47:32];
      `Push64C:
         VFF_IN <= DATA_REG[31:16];
      `Push64D:
         VFF_IN <= DATA_REG[15:0];
      default:
         VFF_IN <= DATA_REG[15:0];
   endcase
end



///////////////////////////////////////////////////////////////
//                                                           //
// FIFO for Readback data from VME                           //
//                                                           //
///////////////////////////////////////////////////////////////
 
//defparam VME_dwrt_ptr.width = 10;
//defparam VME_drd_ptr.width = 10;
//defparam VME_FF_cntr.width = 10;
defparam VME_dwrt_ptr.width = 4;
defparam VME_drd_ptr.width = 4;
defparam VME_FF_cntr.width = 4;

cnt_up VME_dwrt_ptr (.clk(CLK),.inc(PUSH),.r(RST),.count(VME_WADDR));
// 1k X 16 Dual Port RAM for VME readback data
//dpm_1kX18 VME_fifo(.clk(CLK),.we(PUSH),.a(VME_WADDR),.dpra(VME_RADDR),.di({EOP_WR,VLDT,VFF_IN}),.dpo({EOP_RD,VLDT_RD,VFF_OUT})); 
dpm_16X18 VME_fifo(.clk(CLK),.we(PUSH),.a(VME_WADDR),.dpra(VME_RADDR),.di({EOP_WR,VLDT,VFF_IN}),.dpo({EOP_RD,VLDT_RD,VFF_OUT})); 
cnt_up  VME_drd_ptr (.clk(CLK),.inc(V_POP),.r(RST),.count(VME_RADDR));

cnt_up_dwn VME_FF_cntr (.clk(CLK),.ce(VFF_CE),.dir(VFF_DIR),.r(RST),.count(VFF_CNT));

always @ (PUSH or POP or VFF_MT)
begin
  casex ({VFF_MT,PUSH,POP})
     3'b001:
       begin                  // count down
         VFF_CE <= 1'b1;
         VFF_DIR <= 1'b0;
         V_POP <= 1'b1;         // Increment address
       end
     3'bx10,3'b111:
       begin
         VFF_CE <= 1'b1;          // count up
         VFF_DIR <= 1'b1;
         V_POP <= 1'b0;         // Don't increment address
       end
     3'b011:
       begin                  // hold
         VFF_CE <= 1'b0;
         VFF_DIR <= 1'b1;
         V_POP <= 1'b1;         // Increment address
       end
     default:                  // hold
       begin
         VFF_CE <= 1'b0;
         VFF_DIR <= 1'b1;
         V_POP <= 1'b0;
       end
  endcase
end

///////////////////////////////////////////////////////////////
//                                                           //
// Read FIFO read control                                    //
//                                                           //
///////////////////////////////////////////////////////////////

always @(posedge CLK or posedge RST)
begin: VME_RD_FFRD_CTRL_FSM
   if(RST)
      VFFR_ST <= `VR_idle;
   else
      case(VFFR_ST)
         `VR_idle:
            begin
               if(!VFF_MT)
                  VFFR_ST <= `Get_Bus;
               else 
                  VFFR_ST <= `VR_idle;
            end
         `Get_Bus:
            begin
               if(TB_BG_VMER)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Get_Bus;
            end
         `Pop_VFF:
            begin
               if(VD1 && EOP_RD && !VLDT_RD)
                  VFFR_ST <= `GbE_Send;
               else if(VD1 && EOP_RD && VLDT_RD)
                  VFFR_ST <= `Last_Word;
               else if(!VFF_MT)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Wait4NMT;
            end
         `Wait4NMT:
            begin
               if(!VFF_MT)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Wait4NMT;
            end
         `Last_Word:
            VFFR_ST <= `Send_Gap;
         `Send_Gap:
            VFFR_ST <= `GbE_Send;
         `GbE_Send:
            VFFR_ST <= `Rel_Bus;
         `Rel_Bus:
            begin
               if(!TB_BG_VMER)
                  VFFR_ST <= `VR_idle;
               else 
                  VFFR_ST <= `Rel_Bus;
            end
         default:
            VFFR_ST <= `VR_idle;
      endcase
end

always @(VFFR_ST or VFF_MT or VD1 or EOP_RD)
begin
   case (VFFR_ST)
      `Pop_VFF:
         POP <= !VFF_MT && !(VD1 && EOP_RD);
      default:
         POP <= 0;
   endcase
end
always @(VFFR_ST)
begin
   case (VFFR_ST)
      `VR_idle,`Rel_Bus:
         VMER_BR <= 0;
      default:
         VMER_BR <= 1;
   endcase
end
always @(VFFR_ST)
begin
   case (VFFR_ST)
      `GbE_Send:
         begin
            SEND_NORM <= 1;
         end
      default:
         begin
            SEND_NORM <= 0;
         end
   endcase
end

always @(posedge CLK)
begin
   if(VMER_OE)
      DATA_OUT <= VFF_OUT;
   else
      DATA_OUT <= 16'hZZZZ;
end
always @(posedge CLK)
begin
   VD1 <= POP;
   NORM_DAT <= VD1 && VLDT_RD;
end
always @(posedge CLK)
begin
   TXTYPE <= {8'b000001,DATA_SIZE};
end

endmodule
