// Verilog model  - Mon Oct 18 13:53:11 2004

`timescale 1ns / 1ps

module vme_master(ACFAIL, ACKN, AD_MOD, A_FROM, BCLR, BERR, BUS_GRANTED, DTACK, D_FROM,
      EXECUTE, IN_ADDR, IN_DATA, LAST_WORD, LWORD_FROM, MASTER_ENA, MON_AS, NEXT_RDY, RETRY,
      SYSCLK, USRCLK, DV1024CLK,
      SYSFAIL, SYSRESET, VRST, DATA_SZ, TRNS_TYP, DLY_TYP, WRT_RDB, A, AM, AS, BUSY,
      D, DAV, DT_SZ, DRV_ADDR, DRV_AM, DRV_AS, DRV_DATA, DRV_DS,
      DRV_LWORD, DRV_WRITE, DS0, DS1, ERR_REG, LWORD, NEXT_WRD, OUT_DATA, REQ_BUS, WRITE, TEST_OUT);

    input ACFAIL;
    input ACKN;
    input [5:0] AD_MOD;
    input [31:1] A_FROM;
    input BCLR;
    input BERR;
    input BUS_GRANTED;
    input DTACK;
    input [31:0] D_FROM;
    input EXECUTE;
    input [63:0] IN_ADDR;
    input [63:0] IN_DATA;
    input LAST_WORD;
    input LWORD_FROM;
    input MASTER_ENA;
    input MON_AS;
    input NEXT_RDY;
    input RETRY;
    input SYSCLK;
    input USRCLK;
    input DV1024CLK;
    input SYSFAIL;
    input SYSRESET;
    input VRST;
    input [1:0] DATA_SZ;
    input [1:0] TRNS_TYP;
    input [2:0] DLY_TYP;
    input WRT_RDB;
   output [31:1] A;
   output [5:0] AM;
   output AS;
   output BUSY;
   output [31:0] D;
   output DAV;
   output [1:0]DT_SZ;
   output DRV_ADDR;
   output DRV_AM;
   output DRV_AS;
   output DRV_DATA;
   output DRV_DS;
   output DRV_LWORD;
   output DRV_WRITE;
   output DS0;
   output DS1;
   output [7:0] ERR_REG;
   output LWORD;
   output NEXT_WRD;
   output [63:0] OUT_DATA;
   output REQ_BUS;
   output WRITE;
   output [7:0] TEST_OUT;
                          
reg [7:0] TEST_OUT;
reg [31:1] A;
reg [5:0] AM;
reg AS;
reg BUSY;
reg [31:0] D;
reg DAV;
reg DRV_ADDR;
reg DRV_AM;
reg DRV_AS;
reg DRV_DATA;
reg DRV_DS;
reg DRV_LWORD;
reg DRV_WRITE;
reg DS0;
reg DS1;
reg [7:0] ERR_REG;
reg LWORD;
reg [63:0] OUT_DATA;
reg REQ_BUS;
reg NEXT_WRD;

reg NOT_SUP;
reg EXT_3U;
reg EXT_6U;
reg RSVD;
reg UD;
reg BLT;
reg MBLT;
reg LCK;
reg CR;
reg A64;
reg A40;
reg A32;
reg A24;
reg A16;

reg ENA_SDAS1;
reg DLY_ENA_SDAS_8;
reg ENA_SDWR1;
reg DLY_ENA_SDWR_8;

reg START_PULSE;
reg ENA_SDAS0;
reg ENA_SDWR0;
reg SET_DRV_AS;
reg SET_DRV_WRITE;
reg SET_DS_ENA;
reg ESDS0;

//wire START_PULSE;
//wire ENA_SDAS0;
//wire ENA_SDWR0;
//wire SET_DRV_AS;
//wire SET_DRV_WRITE;
//wire SET_DS_ENA;
//wire ESDS0;

reg RST_DRV_AS;
reg RELEASE_WRT;
    
reg SET_AS;
reg RST_AS;

reg ESDS1, DESDS_8;
reg DS_ENA;

reg RST_DS_ENA;

reg ADD_PHASE;
reg END_ADDR;
reg END_A;
reg END_B;
reg END_D;
reg END;
reg ED0,ED1;
   
reg [4:0] MSTR_ST;
reg LOAD_DNA;
reg LAST_ENA;
wire LAST_CYCLE;
reg [63:0] FULL_ADDR;
reg [63:0] FULL_DATA;
reg [31:0] DLY_CNT;
reg LOAD_DLY;
reg LOADED;
reg DLY_ENA;
wire DLY_END;
//wire DCK_USR_CLR;
//reg  DCK_USR_CLR_1;
//reg  DCK_USR_ENA;
wire DCK_DV1024_CLR;
reg  DCK_DV1024_CLR_1;
reg  DCK_DV1024_ENA;
reg INT_DS1;
reg INT_DS0;
reg INT_WRITE;
reg [1:0] DT_SZ;
reg [1:0] TR_TP;
reg [2:0] DL_TP;
reg ASD60;
reg ASD40;
reg DTACK_D25;
reg AD0,AD1,AD2,AD3,AD4;
reg AD5,AD6,AD7,AD8,AD9;
reg AD10,AD11,AD12,AD13,AD14;
reg SD0,SD1,SD2,SD3,SD4;
reg SD5,SD6,SD7,SD8,SD9,SD10;
reg DA0,DA1,DA2,DA3,DA4;
reg DA5,DA6,DA7,DA8;
reg DT0,DT1,DT2,DT3,DT4;
reg DT5;
reg DDD0,DDD1,DDD2,DDD3,DDD4;
reg DDD5,DDD6,DDD7,DDD8;
reg DWD0,DWD1,DWD2,DWD3,DWD4;
reg DWD5,DWD6,DWD7,DWD8;
reg DSAD0,DSAD1,DSAD2,DSAD3,DSAD4;
reg DSAD5,DSAD6,DSAD7,DSAD8,DSAD9;
reg DSAD10,DSAD11;
reg START,START0,START1;

wire DSA;
wire AS_HIGH_60;
wire AS_HIGH_40;
reg  AS_DRV_35;
reg  AS_HOLD_40;
wire RST_END;
reg  RELEASE_AM;
reg  RELEASE_DS;
wire RAMD;
wire RELEASE_DATA;
reg  DS_VALDAT_35;
reg  DS_FIRST_35;
reg  DS_HIGH_40;

wire DONE;
reg  DONE1;
wire RST;
wire PRBS;

reg DSR1;
reg DTACKR1;
reg DTACK_D25R1;

wire TRAIL_EDG_DS;
wire LEAD_EDG_DTACK;
wire TRAIL_EDG_DTACK;
wire LEAD_EDG_DTACK_D25;

`ifdef HEADER
`else
`include "header.v"
`endif

initial
begin
   AS = 0;
   DRV_ADDR = 0;
   DRV_AM = 0;
   DRV_AS = 0;
   DRV_DATA = 0;
   DRV_DS = 0;
   DRV_LWORD = 0;
   DRV_WRITE = 0;
   DS_ENA = 0;
   DS0 = 0;
   DS1 = 0;
   LWORD = 0;
   ADD_PHASE = 0;
   END_ADDR = 0;
   END_A = 0;
   END_B = 0;
   END_D = 0;
   END = 0;
end            

assign PRBS = 2'b00;
assign RST = VRST || SYSRESET;
assign RST_END = DONE1 || SYSRESET;
assign DSA = DS0 || DS1;
assign LAST_CYCLE = LAST_ENA && LAST_WORD; 
assign WRITE = INT_WRITE;
assign DLY_END = (DLY_CNT == 32'h00000000);
//assign DCK_USR_CLR = DCK_USR_ENA || RST;
assign DCK_DV1024_CLR = DCK_DV1024_ENA || RST;
//
assign AS_HIGH_60 = MON_AS || !ASD60;
assign AS_HIGH_40 = MON_AS || !ASD40;
//
//assign START_PULSE = START && !START1;
//assign ESDS0   = DS_HIGH_40 && DS_FIRST_35 && (DS_VALDAT_35 || !WRITE) && MON_AS && !DTACK && !BERR;
//assign SET_DS_ENA   = ESDS0 && !DESDS_8;
//assign ENA_SDAS0   =  START && AS_HIGH_60 && AS_DRV_35;
//assign SET_DRV_AS = ENA_SDAS0 && !DLY_ENA_SDAS_8;
//assign ENA_SDWR0   = START && !DTACK && !BERR;
//assign SET_DRV_WRITE = ENA_SDWR0 && !DLY_ENA_SDWR_8;
//
assign RAMD = END && AS_HOLD_40;
assign DONE = RELEASE_AM && RELEASE_WRT;
assign RELEASE_DATA = RELEASE_AM;
//
assign TRAIL_EDG_DS = !DSA & DSR1;
assign LEAD_EDG_DTACK = DTACK & !DTACKR1;
assign TRAIL_EDG_DTACK = !DTACK & DTACKR1;
assign LEAD_EDG_DTACK_D25 = DTACK_D25 & !DTACK_D25R1;


always @(posedge SYSCLK)
begin
   TEST_OUT[7] <= EXECUTE;
   TEST_OUT[6] <= DAV;
   TEST_OUT[5] <= BUSY;
   TEST_OUT[4:0] <= MSTR_ST;
//   TEST_OUT[4] <= LAST_ENA;
//   TEST_OUT[3] <= LAST_CYCLE;
//   TEST_OUT[2] <= RELEASE_AM;
//   TEST_OUT[1] <= END;
//   TEST_OUT[0] <= DONE;
//   TEST_OUT <= 8'h00;
end

always @(posedge SYSCLK)
begin
   START_PULSE   <= START && !START1;
   ESDS0         <= DS_HIGH_40 && DS_FIRST_35 && (DS_VALDAT_35 || !WRITE) && MON_AS && !DTACK && !BERR;
   SET_DS_ENA    <= ESDS0 && !DESDS_8;
   ENA_SDAS0     <= START && AS_HIGH_60 && AS_DRV_35;
   SET_DRV_AS    <= ENA_SDAS0 && !DLY_ENA_SDAS_8;
   ENA_SDWR0     <= START && !DTACK && !BERR;
   SET_DRV_WRITE <= ENA_SDWR0 && !DLY_ENA_SDWR_8;
end

always @(posedge USRCLK)
begin
   LOADED <= LOAD_DLY;
end


//always @(posedge SYSCLK)
always @(posedge USRCLK)
begin
//   DCK_USR_CLR_1 <= DCK_USR_CLR;
   DCK_DV1024_CLR_1 <= DCK_DV1024_CLR;
end

//always @(posedge USRCLK or posedge DCK_USR_CLR_1)
//begin
//   if(DCK_USR_CLR_1)
//      DCK_USR_ENA <= 0;
//   else
//      DCK_USR_ENA <= 1;
//end
always @(posedge DV1024CLK or posedge DCK_DV1024_CLR_1)
begin
   if(DCK_DV1024_CLR_1)
      DCK_DV1024_ENA <= 0;
   else
      DCK_DV1024_ENA <= 1;
end

//always @(posedge SYSCLK or posedge RST)
always @(posedge USRCLK or posedge RST)
begin
   if(RST)
      DLY_CNT <= 32'h00000000;
   else
      if(LOAD_DLY)
         case(DL_TP)
            `No_Dly:
               DLY_CNT <= 32'h00000000;
            `D16nsX16,`D16nsX32,`D16usX16,`D16usX32:
               DLY_CNT <= FULL_ADDR[31:0];
            `D4nsX16,`D4nsX32:
               DLY_CNT <= {2'b00,FULL_ADDR[31:2]};
            default:
               DLY_CNT <= FULL_ADDR[31:0];
         endcase
      else if(DLY_ENA && !DLY_END)
         case(DL_TP)
            `No_Dly:
               DLY_CNT <= 32'h00000000;
            `D4nsX16,`D4nsX32:
               DLY_CNT <= DLY_CNT -1;
            `D16nsX16,`D16nsX32:
               DLY_CNT <= DLY_CNT -1;
//               if(DCK_USR_ENA)
//                  DLY_CNT <= DLY_CNT -1;
//               else
//                  DLY_CNT <= DLY_CNT;
            `D16usX16,`D16usX32:
               if(DCK_DV1024_ENA)
                  DLY_CNT <= DLY_CNT -1;
               else
                  DLY_CNT <= DLY_CNT;
            default:
               DLY_CNT <= DLY_CNT -1;
         endcase
      else
         DLY_CNT <= DLY_CNT;
end



always @(INT_DS0 or INT_DS1 or DS_ENA)
begin
   if(DS_ENA)
      begin
         DS0 <= INT_DS0;
         DS1 <= INT_DS1;
      end
   else
      begin
         DS0 <= 0;
         DS1 <= 0;
      end
end

always @(posedge SYSCLK)
begin
   if(LOAD_DNA)
      begin
         FULL_ADDR <= IN_ADDR;
         FULL_DATA <= IN_DATA;
         AM <= AD_MOD;
         INT_WRITE <= WRT_RDB;
         DT_SZ <= DATA_SZ;
         TR_TP <= TRNS_TYP;
         DL_TP <= DLY_TYP;
      end
   else
      begin
         FULL_ADDR <= FULL_ADDR;
         FULL_DATA <= FULL_DATA;
         AM <= AM;
         INT_WRITE <= INT_WRITE;
         DT_SZ <= DT_SZ;
         TR_TP <= TR_TP;
         DL_TP <= DL_TP;
      end
end

always @(posedge SYSCLK or posedge TRAIL_EDG_DTACK)
begin
   if(TRAIL_EDG_DTACK)
      begin
         DT0 <= 0;
         DT1 <= 0;
         DT2 <= 0;
         DT3 <= 0;
         DT4 <= 0;
         DT5 <= 0;
         DTACK_D25 <= 0;
      end
   else
      begin
         DT0 <= DTACK;
         DT1 <= DT0;
         DT2 <= DT1;
         DT3 <= DT2;
         DT4 <= DT3;
         DT5 <= DT4;
         DTACK_D25 <= DT5;
      end
end
always @(posedge SYSCLK)
begin
   DSR1 <= DSA;
   DTACKR1 <= DTACK;
   DTACK_D25R1 <= DTACK_D25;
   START0 <= START;
   START1 <= START0;
   AD0 <= MON_AS;
   AD1 <= AD0;
   AD2 <= AD1;
   AD3 <= AD2;
   AD4 <= AD3;
   AD5 <= AD4;
   AD6 <= AD5;
   AD7 <= AD6;
   AD8 <= AD7;
   AD9 <= AD8;
   AD10 <= AD9;
   ASD40 <= AD9;
   AD11 <= AD10;
   AD12 <= AD11;
   AD13 <= AD12;
   AD14 <= AD13;
   ASD60 <= AD14;
   SD0 <= MON_AS;
   SD1 <= SD0;
   SD2 <= SD1;
   SD3 <= SD2;
   SD4 <= SD3;
   SD5 <= SD4;
   SD6 <= SD5;
   SD7 <= SD6;
   SD8 <= SD7;
   SD9 <= SD8;
   SD10 <= SD9;
   AS_HOLD_40 <= SD10;
   DA0 <= DRV_ADDR;
   DA1 <= DA0;
   DA2 <= DA1;
   DA3 <= DA2;
   DA4 <= DA3;
   DA5 <= DA4;
   DA6 <= DA5;
   DA7 <= DA6;
   DA8 <= DA7;
   AS_DRV_35 <= DA8;
   DDD0 <= DRV_DATA;
   DDD1 <= DDD0;
   DDD2 <= DDD1;
   DDD3 <= DDD2;
   DDD4 <= DDD3;
   DDD5 <= DDD4;
   DDD6 <= DDD5;
   DDD7 <= DDD6;
   DDD8 <= DDD7;
   DS_VALDAT_35 <= DDD8;
   DWD0 <= DRV_WRITE;
   DWD1 <= DWD0;
   DWD2 <= DWD1;
   DWD3 <= DWD2;
   DWD4 <= DWD3;
   DWD5 <= DWD4;
   DWD6 <= DWD5;
   DWD7 <= DWD6;
   DWD8 <= DWD7;
   DS_FIRST_35 <= DWD8;
   DSAD0 <= DSA;
   DSAD1 <= DSAD0;
   DSAD2 <= DSAD1;
   DSAD3 <= DSAD2;
   DSAD4 <= DSAD3;
   DSAD5 <= DSAD4;
   DSAD6 <= DSAD5;
   DSAD7 <= DSAD6;
   DSAD8 <= DSAD7;
   DSAD9 <= DSAD8;
   DSAD10 <= DSAD9;
   DSAD11 <= DSAD10;
   DS_HIGH_40 <= ~|{DSAD11,DSAD10,DSAD9,DSAD8,DSAD7,DSAD6,DSAD5,DSAD4,DSAD3,DSAD2};
end

always @(posedge SYSCLK or posedge RST)
begin: VME_MASTER_FSM
   if(RST)
      MSTR_ST <= `M_idle;
   else
      case(MSTR_ST)
         `M_idle:
            begin
               if(EXECUTE && !ACFAIL && !SYSFAIL && !BCLR && MASTER_ENA)
                  MSTR_ST <= `Capture1;
               else 
                  MSTR_ST <= `M_idle;
            end
         `Capture1:
            begin
               if(SYSRESET)
                  MSTR_ST <= `M_idle;
               else if(DLY_TYP != `No_Dly)
                  MSTR_ST <= `Load_Delay;
               else
                  MSTR_ST <= `Req_DTB;
            end
         `Req_DTB:          
            begin
               if(SYSRESET)
                  MSTR_ST <= `M_idle;
               else if(BUS_GRANTED)
                  case (PRBS)
                     2'b00:
                        MSTR_ST <= `Wait_4_DTB;
                     2'b01:
                        MSTR_ST <= `R1;
                     2'b10:
                        MSTR_ST <= `R2A;
                     2'b11:
                        MSTR_ST <= `R3A;
                     default:
                        MSTR_ST <= `Wait_4_DTB;
                  endcase
               else
                  MSTR_ST <= `Req_DTB;
            end
         `Load_Delay:
            begin
               if(SYSRESET)
                  MSTR_ST <= `M_idle;
               else if(LOADED)
                  MSTR_ST <= `Delay;
               else
                  MSTR_ST <= `Load_Delay;
            end
         `Delay:
            begin
               if(DLY_END || SYSRESET)
                  MSTR_ST <= `M_idle;
               else
                  MSTR_ST <= `Delay;
            end
         `R1:
            MSTR_ST <= `Wait_4_DTB;
         `R2A:
            MSTR_ST <= `R2B;
         `R2B:
            MSTR_ST <= `Wait_4_DTB;
         `R3A:
            MSTR_ST <= `R3B;
         `R3B:
            MSTR_ST <= `R3C;
         `R3C:
            MSTR_ST <= `Wait_4_DTB;
         `Wait_4_DTB:
            begin
               if(!MON_AS)
                  MSTR_ST <= `Start;
               else
                  MSTR_ST <= `Wait_4_DTB;
            end
         `Start:                   
            begin
               if(DRV_AS && DRV_WRITE)
                  if(A64 || A40 || MBLT)
                     MSTR_ST <= `Add_Phase;
                  else if (TR_TP == `SNGL || TR_TP == `BLOCK || TR_TP == `UNALG) // Single, Block, or Unaligned transfers (SNGL,BLOCK,UNALG)              
                     MSTR_ST <= `Sngl_Block;
                  else if (TR_TP == `RMW) // Read-Modify-Write transfer (RMW)
                     MSTR_ST <= `RMW_1;
                  else              
                     MSTR_ST <= `Sngl_Block;
               else
                  MSTR_ST <= `Start;
            end
         `Add_Phase:
            begin
               if(DTACK)
                  MSTR_ST <= `Wait_4_DTACK_Rel;
               else
                  MSTR_ST <= `Add_Phase;
            end
         `Wait_4_DTACK_Rel:
            begin
               if(!DTACK)
                  MSTR_ST <= `Sngl_Block;
               else
                  MSTR_ST <= `Wait_4_DTACK_Rel;
            end
         `Sngl_Block:
            begin
               if(DTACK && WRITE)
                  MSTR_ST <= `M_Write;
               else if(DTACK_D25 && !WRITE)
                  MSTR_ST <= `M_Read;
               else
                  MSTR_ST <= `Sngl_Block;
            end
         `M_Write:
            begin
               if(!DSA)
                  MSTR_ST <= `Cycle_Done;
               else
                  MSTR_ST <= `M_Write;
            end
         `M_Read:
            begin
               if(!DSA && ACKN)
                  MSTR_ST <= `Cycle_Done;
               else
                  MSTR_ST <= `M_Read;
            end
         `RMW_1:
            begin
               if(DTACK_D25)
                  MSTR_ST <= `RMW_Read;
               else
                  MSTR_ST <= `RMW_1;
            end
         `RMW_Read:
            begin
               if(!DSA && ACKN)
                  MSTR_ST <= `RMW_2;
               else
                  MSTR_ST <= `RMW_Read;
            end
         `RMW_2:
            begin
               if(DTACK)
                  MSTR_ST <= `RMW_Write;
               else
                  MSTR_ST <= `RMW_2;
            end
         `RMW_Write:
            begin
               if(!DSA)
                  MSTR_ST <= `Cycle_Done;
               else
                  MSTR_ST <= `RMW_Write;
            end
         `Cycle_Done:
            begin
               if(LAST_CYCLE)
                  MSTR_ST <= `Xfer_Done;
               else
                  MSTR_ST <= `Next_Cycle;
            end
         `Next_Cycle:
            begin
               if(NEXT_RDY)
                  MSTR_ST <= `Sngl_Block;
               else
                  MSTR_ST <= `Next_Cycle;
            end
         `Xfer_Done:                    
            begin
               if(!DRV_ADDR && !DRV_WRITE)
                  MSTR_ST <= `M_idle;
               else
                  MSTR_ST <= `Xfer_Done;
            end
         default:
            MSTR_ST <= `M_idle;
      endcase
end

always @(MSTR_ST)
begin
   case (MSTR_ST)
      `Start:
         begin
            START <= 1;
         end
      default:
         begin
            START <= 0;
         end
   endcase
end

always @(MSTR_ST)
begin
   case (MSTR_ST)
      `Load_Delay:
         begin
            DLY_ENA <= 0;
            LOAD_DLY <= 1;
         end
      `Delay:
         begin
            DLY_ENA <= 1;
            LOAD_DLY <= 0;
         end
      default:
         begin
            DLY_ENA <= 0;
            LOAD_DLY <= 0;
         end
   endcase
end

always @(MSTR_ST)
begin
   case (MSTR_ST)
      `M_idle,`Capture1:
         begin
            BUSY <= 0;
            REQ_BUS <= 0;
         end
      `Req_DTB:
         begin
            BUSY <= 0;
            REQ_BUS <= 1;
         end
      `Load_Delay,`Delay:
         begin
            BUSY <= 1;
            REQ_BUS <= 0;
         end
      default:
         begin
            BUSY <= 1;
            REQ_BUS <= 1;
         end
   endcase
end
always @(MSTR_ST)
begin
   case (MSTR_ST)
      `Capture1:
         begin
            LOAD_DNA <= 1;
         end
      default:
         begin
            LOAD_DNA <= 0;
         end
   endcase
end
always @(MSTR_ST)
begin
   case (MSTR_ST)
      `M_Read,`RMW_Read:
         begin
            DAV <= 1;
         end
      default:
         begin
            DAV <= 0;
         end
   endcase
end
always @(MSTR_ST)
begin
   case (MSTR_ST)
      `Next_Cycle:
         begin
            NEXT_WRD <= 1;
         end
      default:
         begin
            NEXT_WRD <= 0;
         end
   endcase
end
always @(MSTR_ST)
begin
   case (MSTR_ST)
      `Sngl_Block,`M_Write,`M_Read,`RMW_1,`RMW_2,`RMW_Read,`RMW_Write,`Cycle_Done,`Next_Cycle,`Xfer_Done:
         begin
            LAST_ENA <= 1;
         end
      default:
         begin
            LAST_ENA <= 0;
         end
   endcase
end

always @(posedge SYSCLK)
begin
   if (END_ADDR)
      ADD_PHASE <= 0;
   else if ((MSTR_ST == `Wait_4_DTB)&&(A64 || A40 || MBLT))
      ADD_PHASE <= 1;
   else
      ADD_PHASE <= ADD_PHASE;
end

always @(AM)
begin: AM_DCode // Address Modifier Decode
   case(AM[5:3])
      3'd0:
          begin
             case(AM[2:0])
                3'd0: // A64 64-bit block transfer MBLT
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000010010000; 
                3'd1: // A64 single transfer access
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000010000;
                3'd2,3'd6,3'd7:        // Reserved
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10010000000000;
                3'd3: // A64  block transfer BLT
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000100010000;
                3'd4: // A64  lock command LCK
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000001010000;
                3'd5: // A32  lock command LCK
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000001000100;
                default:
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000000000;
             endcase
          end
      3'd1:
          begin
             {A64,A40,A32,A24,A16} <= 5'b00100;
             {EXT_3U,EXT_6U,RSVD,UD} <= 4'h0; 
             case(AM[2:0])
                3'd0,3'd4: // A32 non-priv./supvrsy 64-bit block transfer MBLT
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b10100; 
                3'd1,3'd2,3'd5,3'd6:        // A32 non-priv./supvrsy , prg/data
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b00000; 
                3'd3,3'd7: // A32  non-priv./supvrsy block transfer BLT
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b11000; 
                default:
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b00000; 
             endcase
          end
      3'd2,3'd3:   // User defined: implemented as A24 for default.
         {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b00001000000010; 
      3'd4:
          begin
             {A64,A40,A32,A24,A16} <= 5'b00000;
             {UD,BLT,MBLT,LCK,CR} <= 5'b00000; 
             case(AM[2:0])
                3'd0: // Extended AM codes for 6U boards
                   {NOT_SUP,RSVD,EXT_3U,EXT_6U} <= 4'b1001;
                3'd1: // Extended AM codes for 3U boards
                   {NOT_SUP,RSVD,EXT_3U,EXT_6U} <= 4'b1010;
                default:
                   {NOT_SUP,RSVD,EXT_3U,EXT_6U} <= 4'b1100;
             endcase
          end
      3'd5:
          begin
             case(AM[2:0])
                3'd0,3'd2,3'd3,3'd6: // Reserved
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10010000000000;
                3'd1,3'd5: // A16 non-priv./supvrsy access
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b00000000000001;
                3'd4: // A16  lock command LCK
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000001000001;
                3'd7: // Configuration ROM/Control & Status Register
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000100000;
                default:
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000000000;
             endcase
          end
      3'd6:
          begin
             case(AM[2:0])
                3'd0,3'd1,3'd3,3'd6: // Reserved
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10010000000000;
                3'd2: // A24  lock command LCK
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000001000010;
                3'd4: // A40  access
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000001000;
                3'd5: // A40  lock command LCK
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000001001000;
                3'd7: // A40BLT 
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000100001000;
                default:
                   {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000000000;
             endcase
          end
      3'd7:
          begin
             {A64,A40,A32,A24,A16} <= 5'b00010;
             {EXT_3U,EXT_6U,RSVD,UD} <= 4'h0; 
             case(AM[2:0])
                3'd0,3'd4: // A24 non-priv./supvrsy 64-bit block transfer MBLT
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b10100; 
                3'd1,3'd2,3'd5,3'd6:        // A24 non-priv./supvrsy , prg/data
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b00000; 
                3'd3,3'd7: // A24  non-priv./supvrsy block transfer BLT
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b11000; 
                default:
                   {NOT_SUP,BLT,MBLT,LCK,CR} <= 5'b00000; 
             endcase
          end
      default:
         {NOT_SUP,EXT_3U,EXT_6U,RSVD,UD,BLT,MBLT,LCK,CR,A64,A40,A32,A24,A16} <= 14'b10000000000000;
   endcase
end

always @(FULL_ADDR or ADD_PHASE or FULL_DATA or A64 or A40 or A32 or A24 or A16 or MBLT or DT_SZ)
begin         // VME address lines
   if(MBLT && (DT_SZ==`Eight))
      if(ADD_PHASE)
         A <= {FULL_ADDR[31:3],2'b00};
      else
         A <= FULL_DATA[63:33];
   else 
      begin
         case({A64,A40,A32,A24,A16})
            5'b00001:
               A <= {16'h0000,FULL_ADDR[15:1]};
            5'b00010:
               A <= {8'h00,FULL_ADDR[23:1]};
            5'b00100:
               A <= FULL_ADDR[31:1];
            5'b01000:
               A <= {8'h00,FULL_ADDR[23:1]};
            5'b10000:
               A <= FULL_ADDR[31:1];
            default:
               A <= 32'h00000000;
         endcase
      end
   
end

      
always @(FULL_DATA or FULL_ADDR or A64 or A40 or ADD_PHASE or DT_SZ)
begin         // VME data lines
   if(ADD_PHASE)
      begin
         case({A64,A40})
            2'b01:
               D <= {16'h0000,FULL_ADDR[31:24],FULL_ADDR[39:32]};
            2'b10:
               D <= {FULL_ADDR[63:40],FULL_ADDR[39:32]};
            default:
               D <= 32'h00000000;
         endcase
      end
   else
      begin
         casex({DT_SZ,FULL_ADDR[0]})
           3'B000: // BYTE (even) D08(E)
              D <= {16'h0000,FULL_DATA[7:0],8'h00};
           3'B001: // BYTE (odd) D08(O)
              D <= {24'h000000,FULL_DATA[7:0]};
           3'B01x: // WORD  D16
              D <= {16'h0000,FULL_DATA[15:0]};
           3'B10x: // LWORD  D32
              D <= FULL_DATA[31:0];
           3'B11x: // EIGHT  D64
              D <= FULL_DATA[31:0];
           default:
              D <= 32'h00000000;
         endcase
      end
end

// Data size mismatch error if EIGHT and not MBLT or MBLT and not Eight
// D64 transfers are specified by specific AM codes.  So data size must match the AM.

always @(DT_SZ or FULL_ADDR[0] or FULL_DATA or MBLT or ADD_PHASE or DL_TP)
begin
   if(DL_TP == `No_Dly)
      case (DT_SZ)
         `Byte:
            begin
               LWORD <= 0;
               INT_DS1 <= !FULL_ADDR[0];
               INT_DS0 <= FULL_ADDR[0];
            end
         `Word:
            begin
               LWORD <= 0;
               INT_DS1 <= 1;
               INT_DS0 <= 1;
            end
         `LWord:
            begin
               LWORD <= 1;
               INT_DS1 <= 1;
               INT_DS0 <= 1;
            end
         `Eight:
            if(MBLT)
               if(ADD_PHASE)
                  begin
                     LWORD <= 1;
                     INT_DS1 <= 1;
                     INT_DS0 <= 1;
                  end
               else 
                  begin
                     LWORD <= FULL_DATA[32];
                     INT_DS1 <= 1;
                     INT_DS0 <= 1;
                  end
            else
               begin
                  LWORD <= 0;
                  INT_DS1 <= 0;
                  INT_DS0 <= 0;
               end
         default:
            begin
               LWORD <= 0;
               INT_DS1 <= 0;
               INT_DS0 <= 0;
            end
      endcase
   else
      begin
         LWORD <= 0;
         INT_DS1 <= 0;
         INT_DS0 <= 0;
      end
end


always @(posedge SYSCLK)
begin
   if (RELEASE_AM)
      DRV_AM <= 0;
   else if (START_PULSE)
      DRV_AM <= 1;
   else
      DRV_AM <= DRV_AM;
end

always @(posedge SYSCLK)
begin
   if (RELEASE_DS)
      DRV_DS <= 0;
   else if (START_PULSE)
      DRV_DS <= 1;
   else
      DRV_DS <= DRV_DS;
end

always @(posedge SYSCLK)
begin
   if ((!(MBLT && WRITE) && END_ADDR) || RELEASE_AM)
      begin
         DRV_ADDR <= 0;
         DRV_LWORD <= 0;
      end
   else if (START_PULSE)
      begin
         DRV_ADDR <= 1;
         DRV_LWORD <= 1;
      end
   else
      begin
         DRV_ADDR <= DRV_ADDR;
         DRV_LWORD <= DRV_LWORD;
      end
end

always @(posedge SYSCLK)
begin
   ENA_SDAS1 <=        ENA_SDAS0;
   DLY_ENA_SDAS_8 <= ENA_SDAS1;
   SET_AS <= SET_DRV_AS;
   RST_AS <= RELEASE_AM;
   RST_DRV_AS <= RST_AS || VRST;
end
//
always @(posedge SYSCLK)
begin: DRV_AS_REG
   if (RST_DRV_AS)
      DRV_AS <= 0;
   else if (SET_DRV_AS)
      DRV_AS <= 1;
   else
      DRV_AS <= DRV_AS;
end
//
always @(posedge SYSCLK)
begin: AS_REG
   if (RST_AS)
      AS <= 0;
   else if (SET_AS)
      AS <= 1;
   else
      AS <= AS;
end

//////////////////////////////////////////////////////////////////
// Temporary fix for Slaves that rely on raw address lines      //
// in order to maintain the DATA on the bus after DTACK         //
// and before the trailing edge of the data strobes.            // 
//////////////////////////////////////////////////////////////////

// Should use leading edge of DTACK to release the address lines 

//always @(posedge SYSCLK or negedge DRV_ADDR)
//begin
//   if (!DRV_ADDR)
//      END_ADDR <= 0;
//   else 
//      if(LEAD_EDG_DTACK) 
//         END_ADDR <= (MSTR_ST == `Add_Phase) || (MSTR_ST == `Sngl_Block) || (MSTR_ST == `RMW_2);
//      else
//         END_ADDR <= END_ADDR;
//end

// Instead use trailing edge of data strobes to release the address lines

always @(posedge SYSCLK or negedge DRV_ADDR)
begin
   if (!DRV_ADDR)
      END_ADDR <= 0;
   else
      if(TRAIL_EDG_DS) 
         END_ADDR <= (MSTR_ST == `M_Read) || (MSTR_ST == `M_Write) || (MSTR_ST == `RMW_Write);
      else
         END_ADDR <= END_ADDR;
end

//////////////////////////////////////////////////////////////////
//         
//always @(posedge SYSCLK or posedge RST_END)
//begin
//   if (RST_END)
//      END_A <= 0;
//   else 
//      if(LEAD_EDG_DTACK) 
//         END_A <= LAST_CYCLE;
//      else
//         END_A <= END_A;
//end
always @(posedge SYSCLK or posedge RST_END)
begin
   if (RST_END)
      END_A <= 0;
   else 
      if(TRAIL_EDG_DS) 
         END_A <= LAST_CYCLE;
      else
         END_A <= END_A;
end
//
//always @(posedge SYSCLK or posedge RST_END)
//begin
//   if (RST_END)
//      END_B <= 0;
//   else 
//      if(TRAIL_EDG_DTACK) 
//         END_B <= LAST_CYCLE;
//      else
//         END_B <= END_B;
//end
always @(posedge SYSCLK or posedge RST_END)
begin
   if (RST_END)
      END_B <= 0;
   else 
      if(TRAIL_EDG_DS) 
         END_B <= LAST_CYCLE;
      else
         END_B <= END_B;
end
//
//////////////////////////////////////////////////////////////////

always @(END_A or END_B or MBLT or INT_WRITE)
begin
   if(MBLT && !INT_WRITE)
      END <= END_B;
   else
      END <= END_A;
end

always @(posedge SYSCLK or posedge RST_END)
begin
   if (RST_END)
      END_D <= 0;
   else 
      if(TRAIL_EDG_DS) 
         END_D <= LAST_CYCLE;
      else
         END_D <= END_D;
end

always @(posedge SYSCLK)
begin              // 10nS holdoff from trailing edge of DSB to release of WRITE
   ED0 <= END_D;
   ED1 <= ED0;
   RELEASE_WRT <= ED1 || VRST;
   RELEASE_DS <= ED1 || VRST;
   RELEASE_AM <= RAMD || VRST;
   DONE1 <= DONE;
end


always @(posedge SYSCLK)
begin
   ENA_SDWR1 <= ENA_SDWR0;
   DLY_ENA_SDWR_8 <= ENA_SDWR1;
   if (RELEASE_WRT)
      DRV_WRITE <= 0;
   else if (SET_DRV_WRITE)
      DRV_WRITE <= 1;
   else
      DRV_WRITE <= DRV_WRITE;
end
         

always @(posedge SYSCLK)
begin
   if (RELEASE_DATA)
      DRV_DATA <= 0;
   else if (SET_DRV_WRITE)
      if(WRITE)
         DRV_DATA <= 1;
      else
         DRV_DATA <= 0;
   else
      DRV_DATA <= DRV_DATA;
end

always @(posedge SYSCLK)
begin
   ESDS1 <= ESDS0;
   DESDS_8 <= ESDS1;
   if (RST_DS_ENA)
      DS_ENA <= 0;
   else if (SET_DS_ENA)
      DS_ENA <= 1;
   else
      DS_ENA <= DS_ENA;
end

always @(DTACK or BERR or DTACK_D25 or WRITE)
begin
   if(WRITE)
      RST_DS_ENA <= DTACK || BERR;
   else
      RST_DS_ENA <= DTACK_D25 || BERR;
end

      
always @(posedge SYSCLK or posedge ACKN)
begin         // VME data lines
   if (ACKN)
      OUT_DATA <= 64'h0000000000000000;
   else
      if(LEAD_EDG_DTACK_D25) 
         casex({DT_SZ,FULL_ADDR[0]})
            3'B000: // BYTE (even) D08(E)
               OUT_DATA <= {56'h00000000000000,D_FROM[15:8]};
            3'B001: // BYTE (odd) D08(O)
               OUT_DATA <= {56'h00000000000000,D_FROM[7:0]};
            3'B01x: // WORD  D16
               OUT_DATA <= {48'h000000000000,D_FROM[15:0]};
            3'B10x: // LWORD  D32
               OUT_DATA <= {32'h00000000,D_FROM[31:0]};
            3'B11x: // EIGHT  D64
               OUT_DATA <= {A_FROM,LWORD_FROM,D_FROM};
            default:
               OUT_DATA <= 64'h0000000000000000;
         endcase
      else
         OUT_DATA <= OUT_DATA;
end

   

endmodule
